//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ReadForm.h"
#include "Form.h"
#include "..\..\..\include\driver.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmRead *frmRead;


float   fVoltage = 0;
extern  DEVFEATURES     DevFeatures;    // structure for device features
extern  DEVCONFIG_AI    DevCfg;         // structure for DEVCONFIG_AI table
extern  PT_AIConfig     ptAIConfig;     // structure for AIConfig table
extern  PT_AIVoltageIn  ptAIVoltageIn;  // structure for AIVoltageIn table
extern  PT_AIVoltageInExp  ptAIVoltageInExp;  // structure for AIVoltageInExp table
extern  PT_DeviceGetFeatures  ptDevGetFeatures;  // structure for DeviceGetFeatures
extern  PT_AIGetConfig  ptAIGetConfig;  // structure for AIGetConfig table
extern  USHORT      gwChannel ;                      // input channel
extern  USHORT      usExpChan ;                      // expansion channel
extern  USHORT      usBoardID;                      // Board ID
extern  USHORT      usMaxChannel ;                   // max channel
extern  USHORT      gwGain  ;

extern  LONG lDriverHandle;                  //Driver handle
extern  char    szErrMsg[80];               // Use for MESSAGEBOX function
extern  LRESULT ErrCde;                     // Return error code
AnsiString buff;

//---------------------------------------------------------------------------
__fastcall TfrmRead::TfrmRead(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmRead::Timer1Timer(TObject *Sender)
{

    if(DevCfg.Daughter[gwChannel&0xf].dwBoardID == 0)
    {
       ptAIVoltageIn.chan = gwChannel;
       ptAIVoltageIn.gain = ptAIConfig.DasGain;
       ptAIVoltageIn.TrigMode = 0;               // internal trigger
       ptAIVoltageIn.voltage = (FLOAT far *)&fVoltage;

       if ((ErrCde = DRV_AIVoltageIn(lDriverHandle,
                  (LPT_AIVoltageIn)&ptAIVoltageIn)) != 0)
       {
           DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
           Application->MessageBox((LPCSTR)szErrMsg,"Driver Message",MB_OK);
           DRV_DeviceClose((LONG far *)&lDriverHandle);
           Timer1->Enabled = FALSE;
           return ;
       }

    }
    else
    {
       ptAIVoltageInExp.DasChan = gwChannel;
       ptAIVoltageInExp.DasGain = gwGain;
       ptAIVoltageInExp.ExpChan = usExpChan;
       ptAIVoltageInExp.voltage = (FLOAT far *)&fVoltage;

       if  (DevCfg.Daughter[gwChannel&0xf].dwBoardID == BD_PCLD788)
          ptAIVoltageInExp.ExpChan = ((usBoardID << 4) | usExpChan);

       if ((ErrCde = DRV_AIVoltageInExp(lDriverHandle,
                  (LPT_AIVoltageInExp)&ptAIVoltageInExp)) != 0)
       {
           DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
           Application->MessageBox((LPCSTR)szErrMsg,"Driver Message",MB_OK);
           Timer1->Enabled = FALSE;
           DRV_DeviceClose((LONG far *)&lDriverHandle);
           return ;
       }

    }
    //
    // Display Data

    buff.sprintf("%f",fVoltage);
    EdtFreq->Text=buff;


}
//---------------------------------------------------------------------------

void __fastcall TfrmRead::BtnStopClick(TObject *Sender)
{
    Timer1->Enabled = FALSE;

    DRV_DeviceClose((LONG far *)&lDriverHandle);
    MainForm->Show();
    Hide();
   

}
//---------------------------------------------------------------------------

void __fastcall TfrmRead::BtnReadDataClick(TObject *Sender)
{

    Timer1->Enabled = FALSE;
     if(DevCfg.Daughter[gwChannel&0xf].dwBoardID == 0)
    {
       ptAIVoltageIn.chan = gwChannel;
       ptAIVoltageIn.gain = ptAIConfig.DasGain;
       ptAIVoltageIn.TrigMode = 0;               // internal trigger
       ptAIVoltageIn.voltage = (FLOAT far *)&fVoltage;

       if ((ErrCde = DRV_AIVoltageIn(lDriverHandle,
                  (LPT_AIVoltageIn)&ptAIVoltageIn)) != 0)
       {
           DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
           Application->MessageBox((LPCSTR)szErrMsg,"Driver Message",MB_OK);
           DRV_DeviceClose((LONG far *)&lDriverHandle);
           Timer1->Enabled = FALSE;
           return ;
       }

    }
    else
    {
       ptAIVoltageInExp.DasChan = gwChannel;
       ptAIVoltageInExp.DasGain = gwGain;
       ptAIVoltageInExp.ExpChan = usExpChan;
       ptAIVoltageInExp.voltage = (FLOAT far *)&fVoltage;

       if  (DevCfg.Daughter[gwChannel&0xf].dwBoardID == BD_PCLD788)
          ptAIVoltageInExp.ExpChan = ((usBoardID << 4) | usExpChan);

       if ((ErrCde = DRV_AIVoltageInExp(lDriverHandle,
                  (LPT_AIVoltageInExp)&ptAIVoltageInExp)) != 0)
       {
           DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
           Application->MessageBox((LPCSTR)szErrMsg,"Driver Message",MB_OK);
           Timer1->Enabled = FALSE;
           DRV_DeviceClose((LONG far *)&lDriverHandle);
           return ;
       }

    }
    //
    // Display Data

    buff.sprintf("%f",fVoltage);
    EdtFreq->Text=buff;
}
//---------------------------------------------------------------------------


void __fastcall TfrmRead::FormCreate(TObject *Sender)
{
     ScrSampleRate->SetParams(1,1,10);
     Timer1->Enabled = FALSE;
}
//---------------------------------------------------------------------------

void __fastcall TfrmRead::ScrSampleRateChange(TObject *Sender)
{
 Timer1->Enabled = true;
   Timer1->Interval = 1000/ScrSampleRate->Position;

}
//---------------------------------------------------------------------------

