//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "DiintForm.h"
#include "..\..\..\..\include\driver.h"
#include "EventThread.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDiintfrm *Diintfrm;
//---------------------------------------------------------------------------
LONG lDriverHandle;                     //Driver handle
char        szErrMsg[80];               // Use for MESSAGEBOX function
LRESULT     ErrCde;                     // Return error code

static ULONG lDeviceNum;                    //Advantech Device Number in your system
static char szDescription[80];              //description for Select Device
static      DEVFEATURES     DevFeatures;    // structure for device features
static      PT_DeviceGetFeatures  ptDevGetFeatures;

TEventThread*  myEventThread;
BOOL bThreadStop;

extern  char	szStatus[10];
extern  char	szBuf[20];
extern  DWORD   dwCount;
//---------------------------------------------------------------------------
__fastcall TDiintfrm::TDiintfrm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TDiintfrm::FormCreate(TObject *Sender)
{
     //This function is for getting the device number
    if(1 == DRV_SelectDevice(Handle, True, (ULONG*)&lDeviceNum, szDescription)){
        Application->MessageBoxA("Can not Open Select Device Dialog", "Error");
        btnCloseClick(Sender);
    }
    labDeviceName->Caption = AnsiString(szDescription);
    bThreadStop = True;
    txtInterruptCount->Text = "1";
    rdgPriority->ItemIndex = 0;

}
//---------------------------------------------------------------------------

void __fastcall TDiintfrm::btnCloseClick(TObject *Sender)
{
  Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TDiintfrm::btnSelectDeviceClick(TObject *Sender)
{
    //This function is for getting the device number
    DRV_SelectDevice(Handle, True, (ULONG*)&lDeviceNum, szDescription);
    labDeviceName->Caption = AnsiString(szDescription);

}
//---------------------------------------------------------------------------


void __fastcall TDiintfrm::btnEnableClick(TObject *Sender)
{
    PT_EnableEvent ptEnableEvent;

    stIntSource->Caption = "";
    stFrequency->Caption = "";
    stCounts->Caption = "";
    //Open device
    ErrCde = DRV_DeviceOpen(lDeviceNum, (LONG far*)&lDriverHandle);
    if(ErrCde != SUCCESS){
        strcpy(szErrMsg,"Device open error !");
        Application->MessageBoxA((char*)szErrMsg,"Device Open");
        return;
    }

    //set event parameters and enable event
    ptEnableEvent.EventType = ADS_EVT_INTERRUPT_DI0;
    ptEnableEvent.Enabled   = True;
    ptEnableEvent.Count     = txtInterruptCount->Text.ToInt();
    ErrCde = DRV_EnableEvent(lDriverHandle, (LPT_EnableEvent)&ptEnableEvent);

    if(ErrCde != SUCCESS){
        DRV_GetErrorMessage(ErrCde, (LPSTR)szErrMsg);
        Application->MessageBoxA((char*)szErrMsg, "Driver Message");
        return;
    }
    //create thread and suspend it
    myEventThread = new TEventThread(True);

    //set the thread priority
    if(rdgPriority->ItemIndex == 0){
        myEventThread->Priority = tpNormal;
    }else if(rdgPriority->ItemIndex == 1){
        myEventThread->Priority = tpTimeCritical;
    }
    //start the thread
    myEventThread->Resume();
    tmrShow->Enabled = True;
    btnEnable->Enabled = False;
    btnDisable->Enabled = True;
    btnClose->Enabled = False;
    grpDeviceSelection->Enabled = False;
    rdgPriority->Enabled = False;
    txtInterruptCount->Enabled = False;
    bThreadStop = False;
}
//---------------------------------------------------------------------------

void __fastcall TDiintfrm::btnDisableClick(TObject *Sender)
{
     PT_EnableEvent ptEnableEvent;
    //terminate the thread
     myEventThread->Terminate();
     myEventThread->WaitFor();
     //disable event
     tmrShow->Enabled = False;
     ptEnableEvent.EventType = ADS_EVT_INTERRUPT_DI0;
     ptEnableEvent.Enabled   = False;
     ptEnableEvent.Count     = txtInterruptCount->Text.ToInt();
     ErrCde = DRV_EnableEvent(lDriverHandle, (LPT_EnableEvent)&ptEnableEvent);

    if(ErrCde != SUCCESS){
        DRV_GetErrorMessage(ErrCde, (LPSTR)szErrMsg);
        Application->MessageBoxA((char*)szErrMsg, "Driver Message");
        return;
    }

   //close devie
   DRV_DeviceClose((LONG far *)&lDriverHandle);

    btnEnable->Enabled = True;
    btnDisable->Enabled = False;
    btnClose->Enabled = True;
    grpDeviceSelection->Enabled = True;
    rdgPriority->Enabled = True;
    txtInterruptCount->Enabled = True;
    //destory thread object
    delete myEventThread;
}
//---------------------------------------------------------------------------

void __fastcall TDiintfrm::FormClose(TObject *Sender, TCloseAction &Action)
{
    if(!bThreadStop){
        btnDisableClick(Sender);
    }
}
//---------------------------------------------------------------------------

void __fastcall TDiintfrm::tmrShowTimer(TObject *Sender)
{
    stIntSource->Caption = AnsiString(szStatus);
    stFrequency->Caption = AnsiString(szBuf);
    stCounts->Caption = AnsiString(dwCount);
}
//---------------------------------------------------------------------------

