//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FoutForm.h"
#include "..\..\..\..\include\driver.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmFout *frmFout;
//---------------------------------------------------------------------------
static LONG lDriverHandle;                     //Driver handle
static char        szErrMsg[80];               // Use for MESSAGEBOX function
static LRESULT     ErrCde;                     // Return error code

static ULONG lDeviceNum;                    //Advantech Device Number in your system
static char szDescription[80];              //description for Select Device
static      DEVFEATURES     DevFeatures;    // structure for device features
static      PT_DeviceGetFeatures  ptDevGetFeatures;
static      PT_FreqOutStart ptFreqOutStart;
static unsigned       gwFoutSrc;              // frequency output source

static BOOL        bRun = False;


//---------------------------------------------------------------------------
__fastcall TfrmFout::TfrmFout(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmFout::FormCreate(TObject *Sender)
{
  //This function is for getting the device number
    if(1 == DRV_SelectDevice(Handle, True, (ULONG*)&lDeviceNum, szDescription)){
        Application->MessageBoxA("Can not Open Select Device Dialog", "Error");
    }
    labDeviceName->Caption = AnsiString(szDescription);
    cmbFoutSrc->ItemIndex = 6;   //initial 10KHZ

}
//---------------------------------------------------------------------------
void __fastcall TfrmFout::btnSelectDeviceClick(TObject *Sender)
{
   //This function is for getting the device number
    DRV_SelectDevice(Handle, True, (ULONG*)&lDeviceNum, szDescription);
    labDeviceName->Caption = AnsiString(szDescription);

}
//---------------------------------------------------------------------------
void __fastcall TfrmFout::btnStartClick(TObject *Sender)
{
    ErrCde = DRV_DeviceOpen(lDeviceNum, (LONG far *) &lDriverHandle);
    if (ErrCde != SUCCESS){
        strcpy(szErrMsg,"Device open error !");
        Application->MessageBoxA((LPCSTR)szErrMsg,"Device Open");
        return;
    }

    ptDevGetFeatures.buffer = (LPDEVFEATURES )&DevFeatures;
    ptDevGetFeatures.size   = sizeof(DEVFEATURES);
    ErrCde = DRV_DeviceGetFeatures(lDriverHandle, (PT_DeviceGetFeatures*)&ptDevGetFeatures);
    if (ErrCde != SUCCESS){
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBoxA((LPCSTR)szErrMsg,"Driver Message");
        DRV_DeviceClose((LONG far *)&lDriverHandle);
        return;
    }
    if (0 == DevFeatures.usMaxTimerChl){
        Application->MessageBoxA((LPCSTR)"No Counter Channel","Driver Message");
        DRV_DeviceClose((LONG far *)&lDriverHandle);
        return;
    }

    //start Fout
    gwFoutSrc = cmbFoutSrc->ItemIndex;
    switch(gwFoutSrc){
        case 0: ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_EXTER_CLK; break;
        case 1: ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_CLK_N;     break;
        case 2: ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_FOUT_N_M1; break;
        case 3: ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_CLK_10MHZ; break;
        case 4: ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_CLK_1MHZ;  break;
        case 5: ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_CLK_100KHZ;break;
        case 6: ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_CLK_10KHZ; break;
        case 7: ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_CLK_1KHZ;  break;
    }
    ptFreqOutStart.usChannel = cmbChannel->Text.ToInt();
    ptFreqOutStart.usDivider = cmbDivider->Text.ToInt();
    ErrCde = DRV_FreqOutStart((LONG)lDriverHandle,(LPT_FreqOutStart)&ptFreqOutStart);
    if(ErrCde != SUCCESS){
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBoxA((char*)szErrMsg, "Driver Message");
        DRV_DeviceClose((LONG far*)lDriverHandle);
        return;
    }

    grpDeviceSelection->Enabled = False;
    grpChannel->Enabled = False;
    grpFoutSrc->Enabled = False;
    grpDivider->Enabled = False;
    btnExit->Enabled = False;
    btnStart->Enabled = False;
    btnStop->Enabled = True;
    bRun = True;
}
//---------------------------------------------------------------------------
void __fastcall TfrmFout::btnStopClick(TObject *Sender)
{
    //stop Fout
    ErrCde = DRV_FreqOutReset(lDriverHandle,cmbChannel->Text.ToInt());
    if(ErrCde != SUCCESS){
        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
        Application->MessageBoxA((char*)szErrMsg, "Driver Message");
     }
     DRV_DeviceClose((LONG far *)&lDriverHandle);
     bRun = FALSE;
     grpDeviceSelection->Enabled = True;
     grpChannel->Enabled = True;
     grpFoutSrc->Enabled = True;
     grpDivider->Enabled = True;
     btnExit->Enabled = True;
     btnStart->Enabled = True;
     btnStop->Enabled = False;

}
//---------------------------------------------------------------------------
void __fastcall TfrmFout::btnExitClick(TObject *Sender)
{
    Application->Terminate();        
}
//---------------------------------------------------------------------------
void __fastcall TfrmFout::FormClose(TObject *Sender, TCloseAction &Action)
{
    if(True == bRun){
        btnStopClick(Sender);
    }        
}
//---------------------------------------------------------------------------
