//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Init.h"
#include "DataShow.h"
#include "Convert.h"
#include "GainListForm.h"
#include "stdio.h"
#include "..\..\..\include\driver.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFrmInit *FrmInit;

const   MaxEntries = 255;
DEVLIST                 DeviceList[MaxEntries + 1];
DEVFEATURES             DevFeatures;
PT_DeviceGetFeatures    ptDevGetFeatures;
DEVCONFIG_AI            Devconfig_AI;
PT_AIGetConfig          ptAIGetConfig;
PT_EnableEvent          ptEnableEvent;           // Enable event
PT_CheckEvent           ptCheckEvent;      // Check event
PT_FAIIntScanStart      ptFAIStart;
PT_FAITransfer          ptFAITransfer;     // FAITransfer table

USHORT      usStartChan;
USHORT      usChanNum;

long    DeviceHandle;
long    ErrCde;
char    szErrMsg[80];
USHORT      usGainCode[64];
USHORT      usGainIndx[64];
int     giEvtFlag=1;                          // event enable(0)
int     giFifoEnable=0;                       // Fifo
int     giFifoSize;                         // Fifo Size
HGLOBAL hBuf,hUserBuf;
ULONG   gulConvNum;
ULONG   gdwPacerRate;
USHORT  usEventType=0;
USHORT  guDataType = 1;           // display type : FLOAT(1)
USHORT  gwOverrun;
ULONG   ulIntCounter     = 0;  // counter by adInterruptEvent
ULONG   ulBfChgCounter   = 0;
ULONG   ulOverrunCounter = 0;


long ChkErr(long lErrCde)
{
    if (lErrCde != 0)
    {
        DRV_GetErrorMessage(lErrCde, szErrMsg);
        Application->MessageBox(szErrMsg, "Error!!", MB_OK);
        return 1;
    }
    else
        return 0;
}

void TFrmInit::GainCodeFilling()
{
     for (int i=0 ; i< 64 ; i++)
      usGainIndx[i] =cmbOverallGain->ItemIndex;
        
}

//---------------------------------------------------------------------------
__fastcall TFrmInit::TFrmInit(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFrmInit::FormCreate(TObject *Sender)
{
    int i;
    short gnNumOfDevices;
    int MaxEntries;
    short nOutEntries;
 
    MaxEntries = 100;
 
    // Add type of PC Laboratory Card
    ErrCde = DRV_DeviceGetList(&DeviceList[0], MaxEntries, &nOutEntries);
    if (ChkErr(ErrCde))
        return;

    // Return the number of devices which you install in the system using
    // Device Installation
    ErrCde = DRV_DeviceGetNumOfList(&gnNumOfDevices);
    if (ChkErr(ErrCde))
        return;
    
    for (i = 0; i < gnNumOfDevices; i++)
    {
        lstDevice->Items->Add(DeviceList[i].szDeviceName);
    }

    giEvtFlag = 1;                  // event enable(0)
    giFifoEnable = 0;               // Fifo disable(0)
    giFifoSize = FIFO_SIZE;

    lstDevice->ItemIndex = 0;
    lstDeviceClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TFrmInit::lstDeviceClick(TObject *Sender)
{
    int i;
    int tempNum;
    long dwDeviceNum;

    // 
    cmbOverallGain->Enabled = true;
    butConvert->Enabled = false;

    // Reset Gain code setting
    for (i = 0; i <64; i++)
        usGainIndx[i] = 0;
     
    // Clear gain code selection items
    cmbOverallGain->Clear();
     
    // Open selected device for getting more informations
    dwDeviceNum = DeviceList[lstDevice->ItemIndex].dwDeviceNum;
    ErrCde = DRV_DeviceOpen(dwDeviceNum, &DeviceHandle);
    if (ChkErr(ErrCde))
        return;
     
    // Device's informations is stored as Features and configurations
    ptDevGetFeatures.buffer = &DevFeatures;
    ErrCde = DRV_DeviceGetFeatures(DeviceHandle, &ptDevGetFeatures);
    if (ChkErr(ErrCde))
    {
        DRV_DeviceClose(&DeviceHandle);
        return;
    }
     
    // Add Gain code selection list's items
    tempNum = DevFeatures.usNumGain;
    if (tempNum > 0)
    {
        for (i = 0; i < tempNum; i++)
        {
            cmbOverallGain->Items->Add(DevFeatures.glGainList[i].szGainStr);
        }
    }
    cmbOverallGain->ItemIndex = 0;

    // Add analog input start channel items
    cmbStartChl->Clear();
    
    ptAIGetConfig.buffer = &Devconfig_AI;
    ErrCde = DRV_AIGetConfig(DeviceHandle, &ptAIGetConfig);
    if (ChkErr(ErrCde))
    {
        DRV_DeviceClose(&DeviceHandle);
        return;
    }

     tempNum = DevFeatures.usMaxAISiglChl;

     if (tempNum > 0)
    {
        for (i = 0; i < tempNum; i++)
        {
            cmbStartChl->Items->Add(IntToStr(i).c_str());
        }
        
        cmbStartChl->ItemIndex = 0;
        cmbStartChlClick(Sender);
    }

    // Close device
    DRV_DeviceClose(&DeviceHandle);

    radOverall->Enabled = true;
    butConvert->Enabled = true;
}
//---------------------------------------------------------------------------


void __fastcall TFrmInit::cmbChlCountClick(TObject *Sender)
{
    GainCodeFilling();
}
//---------------------------------------------------------------------------

void __fastcall TFrmInit::cmbStartChlClick(TObject *Sender)
{
    int tempNum;
    int i;

      tempNum = DevFeatures.usMaxAISiglChl;

    // Add analog input channel count item
    cmbChlCount->Clear();
    for (i = 1; i <= tempNum - cmbStartChl->Text.ToInt(); i++)
        cmbChlCount->Items->Add(IntToStr(i).c_str());

    // Default selection
    cmbChlCount->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TFrmInit::butConvertClick(TObject *Sender)
{
    PT_EnableEvent ptEnableEvent;
    int i, j;
    ulIntCounter     = 0;  // counter by adInterruptEvent
    ulBfChgCounter   = 0;
    ulOverrunCounter = 0;
    gulConvNum =  editConv->Text.ToInt();
    gdwPacerRate = editPacerRate->Text.ToInt();
    guDataType =  (USHORT)chkFloatData->Checked;
    // 1. Open device
    ErrCde = DRV_DeviceOpen(DeviceList[lstDevice->ItemIndex].dwDeviceNum, &DeviceHandle);
    if (ChkErr(ErrCde))
        return;

    // 2. Set gain list
    usStartChan=cmbStartChl->Text.ToInt();
    usChanNum= cmbChlCount->Text.ToInt();

    int phiChan = usStartChan;
    for (int i=0 ; i< usChanNum ; i++, phiChan++)
    {
       usGainCode[i] =
         DevFeatures.glGainList[usGainIndx[usStartChan+phiChan]].usGainCde;
      if( Devconfig_AI.ulChanConfig & (1<< phiChan) )
        phiChan++;

    }
    
    ptEnableEvent.EventType = ADS_EVT_INTERRUPT |
                              ADS_EVT_BUFCHANGE |
                              ADS_EVT_OVERRUN   |
                              ADS_EVT_TERMINATED;
    ptEnableEvent.Enabled = giEvtFlag;
    giFifoSize = editFifo->Text.ToInt();
    if (chkFifo->Checked && giFifoSize > 0)
        ptEnableEvent.Count = giFifoSize;
    else
        ptEnableEvent.Count = 1;
    ErrCde = DRV_EnableEvent(DeviceHandle, &ptEnableEvent);
    if (ChkErr(ErrCde))
        return;

    // 3. Start AI interrupt funciton
    // 3.1 Fill element of PT_FAIIntScanStart
    ptFAIStart.TrigSrc = radExtTrig->Checked;       // Ext trig mode
    ptFAIStart.SampleRate = editPacerRate->Text.ToInt();
    ptFAIStart.NumChans = cmbChlCount->Text.ToInt();
    ptFAIStart.StartChan = cmbStartChl->Text.ToInt();
    ptFAIStart.GainList = usGainCode;
    ptFAIStart.count = gulConvNum;
    ptFAIStart.cyclic = chkCyclic->Checked;
    if (giFifoEnable == 1 && giFifoSize > 0)
        ptFAIStart.IntrCount = giFifoSize;
    else
        ptFAIStart.IntrCount = 1;
    // Allocate memory
    hBuf = GlobalAlloc(GHND, sizeof(USHORT) * gulConvNum);
    if(hBuf == 0)
    {
        strcpy(szErrMsg, "Not enough memory for buffer");
        Application->MessageBox(szErrMsg, "Driver Message", MB_OK);
        DRV_DeviceClose(&DeviceHandle);
        return;
    }
    ptFAIStart.buffer = (USHORT far *) hBuf;
     // allocate data memory
     if((hUserBuf=(FLOAT far *)GlobalAlloc(GHND, sizeof(FLOAT) * gulConvNum)) == 0)
     {
         lstrcpy((char *) szErrMsg, "Not enough memory for buffer");
         DRV_DeviceClose((LONG far *)&DeviceHandle);
         Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
         return;
     }
    ptFAITransfer.DataBuffer = (FLOAT far  *)GlobalLock(hUserBuf);

    // 3.2 Call advantech API function DRV_FAIIntScanStart
    ErrCde = DRV_FAIIntScanStart(DeviceHandle, &ptFAIStart);
    if (ChkErr(ErrCde))
    {
       ErrCde = DRV_DeviceClose(&DeviceHandle);
       GlobalFree(hBuf);
       return;
    }

    if( giEvtFlag )
       pThread = new CheckThread(false);
    
    // 4. Entering converting form
    FrmConvert->txtInt->Text=IntToStr(0);
    FrmConvert->txtBuffChange->Text=IntToStr(0);

    FrmConvert->Show();
    frmDataShow->Show();
    frmDataShow->Hide();
    FrmInit->Hide();
    FrmConvert->prgsDataCounts->Max = editConv->Text.ToInt();
    FrmConvert->tmrDataCounts->Enabled = True;
}
//---------------------------------------------------------------------------

void __fastcall TFrmInit::butGainListClick(TObject *Sender)
{
    usStartChan=cmbStartChl->Text.ToInt();
    usChanNum= cmbChlCount->Text.ToInt();
    frmGainList->SetGainList();
    frmGainList->Show();
}
//---------------------------------------------------------------------------

void __fastcall TFrmInit::butExitClick(TObject *Sender)
{
    GlobalFree(hBuf);
    Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TFrmInit::chkEventEnableClick(TObject *Sender)
{
    giEvtFlag = chkEventEnable->Checked;        
}
//---------------------------------------------------------------------------

void __fastcall TFrmInit::chkFifoClick(TObject *Sender)
{
    long lFifoSize;
   
    giFifoEnable = chkFifo->Checked;
    if (giFifoEnable == 1)
    {
        editFifo->Enabled = True;
      
        // Step 1: Device open
        ErrCde = DRV_DeviceOpen(DeviceList[lstDevice->ItemIndex].dwDeviceNum, &DeviceHandle);
        if (ChkErr(ErrCde))
            return;
      
        // Step 2: Get FIFO size
        ErrCde = DRV_GetFIFOSize(DeviceHandle, &lFifoSize);
        if (ChkErr(ErrCde))
            return;
      
        // Step 3: Close device
        DRV_DeviceClose (&DeviceHandle);

        giFifoSize = lFifoSize / 2;   // divide by 2 for conversion from byte to word
        editFifo->Text = giFifoSize;
        editConv->Text = IntToStr(lFifoSize);
        
    }
    else
    {
        editFifo->Enabled = False;
        editFifo->Text = "0";
    }
}
//---------------------------------------------------------------------------



bool TFrmInit::CheckEvent()
{
        //TODO: Add your source code here

         ptCheckEvent.EventType = &usEventType;
        if (chkCyclic->Checked )
	{
            ptCheckEvent.Milliseconds = INFINITE;
        }
	else
	{
            ptCheckEvent.Milliseconds = 1000 * (gulConvNum / gdwPacerRate) + 2000;
	}

        if ((ErrCde = DRV_CheckEvent(DeviceHandle,
            (LPT_CheckEvent)&ptCheckEvent)) != 0)
        {
            Application->MessageBox("Check Event Error !","Thread Message",MB_OK);
            return false;
        }
        // Process interrupt event
        if (usEventType & ADS_EVT_INTERRUPT)
        {
            ulIntCounter++;
        }

        // Process buffer change event
        if (usEventType & ADS_EVT_BUFCHANGE)
        {
            ulBfChgCounter++;
        }

        // Process overrun event
        if (usEventType == ADS_EVT_OVERRUN)
        {
            ulOverrunCounter++;
        }
        FrmConvert->txtInt->Text=IntToStr(ulIntCounter);
        FrmConvert->txtBuffChange->Text=IntToStr(ulBfChgCounter);

        // Process terminate event
        if (usEventType & ADS_EVT_TERMINATED)
        {
            // process terminate event
             Terminate();
             return false;
          }

       return true ;


}

void TFrmInit::StopThread()
{
        //TODO: Add your source code here

}

void TFrmInit::Terminate()
{
        //TODO: Add your source code here
         LPVOID temp;
         FrmConvert->tmrDataCounts->Enabled = false;

        if ((ErrCde = DRV_FAIStop(DeviceHandle)) != 0)
        {
            DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
            GlobalUnlock(hBuf);
            GlobalUnlock(hUserBuf);
            GlobalFree(hBuf);
            GlobalFree(hUserBuf);
            DRV_DeviceClose((LONG far *)&DeviceHandle);
            Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
            return;
        }

        ptFAITransfer.ActiveBuf = 0;     // Single buffer
        ptFAITransfer.DataType = guDataType;
        ptFAITransfer.start    = 0;
        ptFAITransfer.count    = gulConvNum;
        ptFAITransfer.overrun  = &gwOverrun;

        if ((ErrCde = DRV_FAITransfer(DeviceHandle,
            (LPT_FAITransfer)&ptFAITransfer)) != 0)
        {
            DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
            GlobalUnlock(hBuf);
            GlobalUnlock(hUserBuf);
            GlobalFree(hBuf);
            GlobalFree(hUserBuf);
            DRV_DeviceClose((LONG far *)&DeviceHandle);
            Application->MessageBox((char *)szErrMsg, "Driver Message", MB_OK);
            return;
        }

        // Display Data
        frmDataShow->Show();
        frmDataShow->lstData->Clear();
        if (guDataType == 0)
           temp = (USHORT far *)ptFAITransfer.DataBuffer;
        else
           temp = (FLOAT far *)ptFAITransfer.DataBuffer;

        char szbuff[100];
        for(int i = 0; i < gulConvNum; ++i)
        {
           if (guDataType == 0)
               sprintf(szbuff,"Buff[%2.2d] = %X",i,((USHORT far *)temp)[i]);
           else
               sprintf(szbuff,"Buff[%2.2d] = %10.6f",i,((float far *)temp)[i]);
               frmDataShow->lstData->Items->Add(szbuff);

        }

        FrmConvert->Close();


        if(pThread!=NULL)
        {
            pThread->Terminate();
            DWORD dwExitCode;
            GetExitCodeThread( (void *)pThread->Handle ,&dwExitCode) ;
            if(dwExitCode == STILL_ACTIVE )
               TerminateThread( (void *)pThread->Handle, dwExitCode);
            pThread = NULL;
        }

        // Free buffer
        GlobalUnlock(hBuf);
        GlobalUnlock(hUserBuf);
        GlobalFree(hBuf);
        GlobalFree(hUserBuf);

}


void __fastcall TFrmInit::cmbOverallGainChange(TObject *Sender)
{
    GainCodeFilling();
}
//---------------------------------------------------------------------------


void __fastcall TFrmInit::radOverallClick(TObject *Sender)
{
    GainCodeFilling();
    

        butGainList->Enabled = False;
        cmbOverallGain->Enabled = True;



}
//---------------------------------------------------------------------------

void __fastcall TFrmInit::radGainListClick(TObject *Sender)
{
        butGainList->Enabled = True;
        cmbOverallGain->Enabled = False;
}
//---------------------------------------------------------------------------

