unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Driver, Thread ;

type
  TfrmMain = class(TForm)
    Label2: TLabel;
    GroupBox9: TGroupBox;
    Label1: TLabel;
    Label3: TLabel;
    editScanNum: TEdit;
    cmbChannel: TComboBox;
    butStart: TButton;
    butStop: TButton;
    lstDevice: TListBox;
    butExit: TButton;
    GroupBox2: TGroupBox;
    radRawData: TRadioButton;
    radVoltage: TRadioButton;
    GroupBox3: TGroupBox;
    radClockInternal: TRadioButton;
    radClockExternal0: TRadioButton;
    radClockExternal1: TRadioButton;
    GroupBox1: TGroupBox;
    Label8: TLabel;
    Label7: TLabel;
    Label13: TLabel;
    Label17: TLabel;
    radPacer: TRadioButton;
    radPost: TRadioButton;
    radDelay: TRadioButton;
    radAbout: TRadioButton;
    editDelayCount: TEdit;
    GroupBox4: TGroupBox;
    Label9: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    radDigital: TRadioButton;
    radAI0: TRadioButton;
    radAI1: TRadioButton;
    radAI3: TRadioButton;
    radAI2: TRadioButton;
    editTrigVolt: TEdit;
    GroupBox5: TGroupBox;
    radCyclic: TRadioButton;
    radNonCyclic: TRadioButton;
    GroupBox6: TGroupBox;
    radRising: TRadioButton;
    radFalling: TRadioButton;
    GroupBox7: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    chkBufferChange: TCheckBox;
    chkTerminate: TCheckBox;
    chkOverrun: TCheckBox;
    editOverrunTime: TEdit;
    chkInterrupt: TCheckBox;
    edtEventCount: TEdit;
    GroupBox8: TGroupBox;
    radOverall: TRadioButton;
    radGainList: TRadioButton;
    cmbGain: TComboBox;
    butGainList: TButton;
    GroupBox10: TGroupBox;
    Label4: TLabel;
    Label6: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    editPacerRate: TEdit;
    GroupBox11: TGroupBox;
    Label5: TLabel;
    editCount: TEdit;
    GroupBox12: TGroupBox;
    radInternal: TRadioButton;
    radExternal: TRadioButton;
    Label24: TLabel;
    Label23: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure lstDeviceClick(Sender: TObject);
    procedure butStartClick(Sender: TObject);
    procedure radGainListClick(Sender: TObject);
    procedure radOverallClick(Sender: TObject);
    procedure butGainListClick(Sender: TObject);
    procedure radPacerClick(Sender: TObject);
    procedure radPostClick(Sender: TObject);
    procedure CheckEvent();
    procedure InterruptEvent();
    procedure BufChangeEvent();
    procedure OverrunEvent();
    procedure TerminateEvent();
    procedure butStopClick(Sender: TObject);
    procedure radCyclicClick(Sender: TObject);
    procedure radNonCyclicClick(Sender: TObject);
    procedure radRawDataClick(Sender: TObject);
    procedure radVoltageClick(Sender: TObject);
    procedure radClockInternalClick(Sender: TObject);
    procedure radClockExternal0Click(Sender: TObject);
    procedure radClockExternal1Click(Sender: TObject);
    procedure radInternalClick(Sender: TObject);
    procedure radExternalClick(Sender: TObject);
    procedure radRisingClick(Sender: TObject);
    procedure radFallingClick(Sender: TObject);
    procedure radDigitalClick(Sender: TObject);
    procedure radAI0Click(Sender: TObject);
    procedure radAI1Click(Sender: TObject);
    procedure radAI2Click(Sender: TObject);
    procedure radAI3Click(Sender: TObject);
    procedure radDelayClick(Sender: TObject);
    procedure radAboutClick(Sender: TObject);
    procedure butExitClick(Sender: TObject);
    procedure cmbGainChange(Sender: TObject);
  private
    { Private declarations }
    chkThread : CheckThread;
  public
    { Public declarations }

  end;

var
  frmMain: TfrmMain;

  DevFeature      : DEVFEATURES;    // structure for device features
  ptDevFeatures    : PT_DeviceGetFeatures ;
  ptFAIDmaExStart  : PT_FAIDmaExStart;   // FAIIntStart table
  ptFAITransfer    : PT_FAITransfer;     // FAITransfer table
  ptFAICheck       : PT_FAICheck;        // FAICheck table
  ptEnableEvent    : PT_EnableEvent;     // Enable event
  ptCheckEvent     : PT_CheckEvent;      // Check event
  hUserBuf         : HGLOBAL;//Pointer;
  hDisplayBuf      : HGLOBAL;

  gdwPacerRate     : Longint  = 250000;               // pacer rate
  gulConvNum       : Longint = 200000;//40960;               // conversion number
  gwStartChl       : Smallint = 0;
  gwChlNum         : Smallint = 1;   // scan channels
  gwDataType       : Smallint = 1;                  // display type : FLOAT(1)
  gwEvtFlag        : Smallint = 1;                  // event enable(0)
  gwActualBufSize  : Longint = 0;               // actual allocate buffer size
  gwFifoEnable     : Smallint = 0;               // Fifo disable(0)

  gwGainList       : Smallint = 0;      // gain list flag
  gdwStartPt       : Longint = 0;
  gdwStopPt        : Longint = 99;    // display points
  gwExtTrig        : Smallint = 0;      // external or internal trigger
  gwClockSrc       : Smallint = 0;		// Clock source
  gwTrigEdge       : Smallint = 0;		// Trigger edge
  gwSRCType        : Smallint = 0;	   // Source type
  gwTrigVol        : single = 0.0;		// Trigger voltage

  gwCyclicMode     : Smallint = 1;    // cyclic or non-cyclic mode
  gwTrigMode       : Smallint = 0;    // Trigger Mode
  gwIntrCount      : Smallint = 1;
  gwCyclicCount    : Longint = 1;    // number of cyclic count

  gwActiveBuf      : Smallint = 0;     // return by FAICheck
  gwOverrun        : Smallint = 0;     // return by FAICheck, FAITransfer
  gwStopped        : Smallint = 0;     // return by FAICheck
  gulRetrieved     : Longint = 0;     // return by FAICheck
  gwHalfReady      : Smallint = 0;     // return by FAICheck
  gwDelayCnt       : Longint = 2;
  bThreadloop      : Boolean = true;

  gwDevice         : Smallint = 0;
  gwSubDevice      : Smallint = 0;      // Device index

  gnNumOfDevices   : Smallint;
  gnNumOfSubdevices: Smallint;  // number of installed devices

   szErrMsg        : string;               // Use for MESSAGEBOX function
   szBuffer        : string;				// Temperatory buffer
  ErrCde           : Longint;                     // Return error code

  DeviceList       : array[0..99] of PT_DEVLIST;
  SubDeviceList    : array[0..99] of PT_DEVLIST;

  DriverHandle     : Longint = 0;         // driver handle
  fVoltageArray    : array[0..64] of single;

  gwGainCde        : array[0..64] of Smallint;
  ReorderGainCode  : array[0..64] of Smallint;

  gwGain            : array[0..64] of Smallint ;
  usStartChan, usChanNum : Smallint;
  gulIntCounter       : Longint = 0;
  gulBfChgCounter     : Longint = 0;
  gulOverrunCounter   : Longint = 0;
  gulOverrunTime      : Longint = 10000;
  gulEventCount       : Longint =  1;
  szCounter           : string;
  MAX_DEVICES         : Longint = 99;

  bBufferChange   : Boolean = true;
  bInterrupt      : Boolean = true;
  bOverrun        : Boolean = true;
  bTerminate      : Boolean = true;


implementation

uses DislpayForm,GainListForm;

{$R *.dfm}
{*************************************************************
 * Function: Handle the error code. If the input error code > 0,
 *           it means some error apperent.  This function can
 *           show the error message to a message box and stop
 *           this application.
 * Input:    The error code.
 * return:   none
 ************************************************************* }
Function DoesErr(var lErrCode: LongInt): integer;
var
  szErrMsg   : string[100];
  pszErrMsg  : PChar;
begin
  {Check the pressed error code}
  If (lErrCode <> 0) Then
  begin
    pszErrMsg := @szErrMsg;
    DRV_GetErrorMessage(lErrCode, pszErrMsg);
    Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
    DoesErr := 1;
  end
  else
    DoesErr := 0;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
    nOutEntries  : Smallint;
    i            : integer;

begin
    ErrCde := DRV_DeviceGetNumOfList(gnNumOfDevices);
    if( DoesErr(ErrCde) = 1 ) then
    Exit;

    if (gnNumOfDevices > MAX_DEVICES )  then
        gnNumOfDevices := MAX_DEVICES;

    // Add type of PC Laboratory Card
    ErrCde := DRV_DeviceGetList(DeviceList[0],gnNumOfDevices, nOutEntries);
    if( DoesErr(ErrCde) = 1 ) then
    Exit;

    // Here MaxEntries = nOutEntries
    for i := 0 to gnNumOfDevices-1 do
        lstDevice.Items.Add( DeviceList[i].szDeviceName );

    for i:=0 to 63 do
        gwGain[i]:=0;

    lstDevice.ItemIndex := gwDevice;
    lstDeviceClick(Sender);

    butStop.Enabled := False;
end;

procedure TfrmMain.lstDeviceClick(Sender: TObject);
var
    i   : Smallint;
begin
    cmbGain.Clear();
    gwDevice := lstDevice.ItemIndex;

    ErrCde := DRV_DeviceOpen(DeviceList[gwDevice].dwDeviceNum, DriverHandle);
    if( DoesErr(ErrCde) = 1 ) then
    Exit;

    // get device features
    ptDevFeatures.buffer := @DevFeature;
    ptDevFeatures.size := SizeOf(DEVFEATURES);
    ErrCde := DRV_DeviceGetFeatures(DriverHandle, ptDevFeatures);
    if DoesErr(ErrCde) = 1  then
    begin
      DRV_DeviceClose(DriverHandle);
      Exit;
    end;


    // initialize Input Range List Combobox with device features
    if (DevFeature.usNumGain <> 0) then
    begin
        for i := 0 to DevFeature.usNumGain-1 do
            cmbGain.Items.Add(DevFeature.glGainList[i].szGainStr);
        cmbGain.ItemIndex := 0;
    end;


    // Initialize Start Channel
    cmbChannel.Clear();
    for i := 0 to DevFeature.usMaxAISiglChl do
    begin
        cmbChannel.Items.Add(InttoStr(i));
    end;
     cmbChannel.ItemIndex := 0;



    // close device
    DRV_DeviceClose(DriverHandle);
end;

procedure TfrmMain.butStartClick(Sender: TObject);
var
     temp  : integer;
     i     : integer;
begin
     gwTrigVol := StrToInt(editTrigVolt.Text);
     gwDelayCnt := StrToInt(editDelayCount.Text);
     gdwPacerRate := StrToInt(editPacerRate.Text);
     gulConvNum := StrToInt(editCount.Text);
     gwStartChl := cmbChannel.ItemIndex;
     gwChlNum :=  StrToInt(editScanNum.Text);
     if(radInternal.Checked) then
       gwExtTrig := 0
     else
       gwExtTrig :=1;


     for i:=0 to 63  do
         gwGainCde[i]:= DevFeature.glGainList[gwGain[i]].usGainCde;


     for i:=0 to gwChlNum-1 do
     begin
         temp := gwStartChl + i;

      	ReorderGainCode[i] := gwGainCde[temp];
     end;

    ErrCde := DRV_DeviceOpen(DeviceList[gwDevice].dwDeviceNum,
             DriverHandle);
     if DoesErr(ErrCde) = 1  then
    begin
      DRV_DeviceClose(DriverHandle);
      Exit;
    end;



     // allocate memory
     hUserBuf :=GlobalAlloc(GPTR, SizeOf(single) *gulConvNum);

     if (hUserBuf = 0 )  then
    begin
      DRV_DeviceClose(DriverHandle);
      Exit;
    end;

     // allocate memory
        hDisplayBuf :=GlobalAlloc(GPTR, SizeOf(single) * gulConvNum);

     if (hDisplayBuf = 0)  then
    begin
      DRV_DeviceClose(DriverHandle);
      Exit;
    end ;
     ptFAITransfer.DataBuffer := Pointer(GlobalLock(hDisplayBuf));

     // enable event
        ptEnableEvent.EventType := 0;
        if( chkBufferChange.Checked ) then
             ptEnableEvent.EventType :=ptEnableEvent.EventType or  ADS_EVT_BUFCHANGE;

        if( chkTerminate.Checked ) then
            ptEnableEvent.EventType := ptEnableEvent.EventType or ADS_EVT_TERMINATED;
        if( chkOverrun.Checked )  then
            ptEnableEvent.EventType := ptEnableEvent.EventType or ADS_EVT_OVERRUN;
        if( chkInterrupt.Checked )  then
            ptEnableEvent.EventType:= ptEnableEvent.EventType or ADS_EVT_INTERRUPT;

        ptEnableEvent.Enabled := 1;
        ptEnableEvent.Count   := StrToInt(edtEventCount.Text) * 2048;


      ErrCde := DRV_EnableEvent(DriverHandle,ptEnableEvent);

       if DoesErr(ErrCde) = 1  then
      begin
         GlobalFree(HGLOBAL(hUserBuf));
         GlobalFree(HGLOBAL(hDisplayBuf));
         DRV_DeviceClose(DriverHandle);
         Exit;
      end;



      ptFAIDmaExStart.TrigSrc	    	:= gwExtTrig;
      ptFAIDmaExStart.TrigMode		:= gwTrigMode;
      ptFAIDmaExStart.ClockSrc		:= gwClockSrc;
      ptFAIDmaExStart.TrigEdge		:= gwTrigEdge;
      ptFAIDmaExStart.SRCType	      	:= gwSRCType;
      ptFAIDmaExStart.CyclicMode     	:= gwCyclicMode;
      ptFAIDmaExStart.TrigVol	     	:= gwTrigVol;
      ptFAIDmaExStart.StartChan 	:= gwStartChl;
      ptFAIDmaExStart.NumChans		:= gwChlNum;
      ptFAIDmaExStart.ulDelayCnt     	:= gwDelayCnt;
      ptFAIDmaExStart.SampleRate     	:= gdwPacerRate;
      ptFAIDmaExStart.GainList		:= @ReorderGainCode[0];
      ptFAIDmaExStart.count	      	:= gulConvNum;
      ptFAIDmaExStart.buffer0	      	:= Pointer(GlobalLock(hUserBuf));

      ErrCde := DRV_FAIDmaExStart(DriverHandle,ptFAIDmaExStart);
       if DoesErr(ErrCde) = 1  then
      begin
         GlobalFree(HGLOBAL(hUserBuf));
         GlobalFree(HGLOBAL(hDisplayBuf));
         DRV_DeviceClose(DriverHandle);
         Exit;
      end;

      bThreadloop:=true;
      chkThread:=CheckThread.Create(false);
 

     frmDisplay.Show();
     frmDisplay.lstBuffer.Visible := false;

     butStart.Enabled := False;
     butStop.Enabled  := True;
     butExit.Enabled  := False;

    butStop.Enabled := true;
    butStart.Enabled := false;
    lstDevice.Enabled := false;
    editScanNum.Enabled := false;
    cmbGain.Enabled := false;
    cmbChannel.Enabled := false;
    gulOverrunTime := StrToInt(editOverrunTime.Text);


    bThreadloop := true;
end;

procedure TfrmMain.radGainListClick(Sender: TObject);
begin
   butGainList.Enabled := true;
   cmbGain.Enabled := false;

end;

procedure TfrmMain.radOverallClick(Sender: TObject);
var
   i   : integer;
begin
  butGainList.Enabled := false;
   cmbGain.Enabled := true;
   for i:=0 to 63 do
      gwGain[i] :=  cmbGain.ItemIndex;


end;

procedure TfrmMain.butGainListClick(Sender: TObject);
begin
     gwStartChl := cmbChannel.ItemIndex;
     gwChlNum :=  StrToInt(editScanNum.Text);

    GainList.SetGainCtrl();

    GainList.ShowModal();

end;

procedure TfrmMain.radPacerClick(Sender: TObject);
begin
   editDelayCount.Enabled:=false;
   radFalling.Enabled := false;
   radRising.Enabled := false;
    radDigital.Enabled := false;
   radAI0.Enabled := false;
   radAI1.Enabled := false;
   radAI2.Enabled := false;
   radAI3.Enabled := false;
   radInternal.Checked := true;
   gwTrigMode:=0;
   radCyclic.Enabled := true;
   radNonCyclic.Enabled := true;

end;

procedure TfrmMain.radPostClick(Sender: TObject);
begin
   editDelayCount.Enabled:=false;
   radFalling.Enabled := true;
   radRising.Enabled := true;
    radDigital.Enabled := true;
   radAI0.Enabled := true;
   radAI1.Enabled := true;
   radAI2.Enabled := true;
   radAI3.Enabled := true;
   radExternal.Checked:=true;
   gwTrigMode:=1;
   gwTrigEdge:=1;
   radFalling.Checked := True;
   radCyclic.Enabled := true;
   radNonCyclic.Enabled := true;
   
   end;

procedure TfrmMain.CheckEvent();
var
    usEventType : integer;
    szData      : string;
begin
    gulIntCounter := 0;
    gulBfChgCounter := 0;
    gulOverrunCounter := 0;

    while( bThreadloop =true )   do
    begin
        ptCheckEvent.EventType := @usEventType;
        if ( gulOverrunTime = 0 ) then
            ptCheckEvent.Milliseconds := INFINITE
        else
            ptCheckEvent.Milliseconds := gulOverrunTime;


        ErrCde := DRV_CheckEvent(DriverHandle,ptCheckEvent);
        if DoesErr(ErrCde) = 1  then
        begin
         butStopClick(nil);
         Exit;
        end;


        // Process interrupt event
        if ((usEventType and ADS_EVT_INTERRUPT)<>0 ) then
            InterruptEvent();

        // Process buffer change event
        if ((usEventType and ADS_EVT_BUFCHANGE)<>0 )  then
            BufChangeEvent();

        // Process overrun event
        if ((usEventType and ADS_EVT_OVERRUN) <>0 ) then
            OverrunEvent();

        // Process terminate event
        if ((usEventType and ADS_EVT_TERMINATED) <>0 )  then
        begin
            TerminateEvent();
            Exit;
        end;

        frmDisplay.Canvas.Lock();
        szCounter := 'Interrupt Counter = '+ IntToStr(gulIntCounter);
        frmDisplay.Canvas.TextOut(20, 40, szCounter );
        szData := 'Buffer change Counter = '+IntToStr(gulBfChgCounter);
       frmDisplay.Canvas.TextOut( 20, 60, szData );
        szData := 'Overrun Counter = '+ IntToStr(gulOverrunCounter);
        frmDisplay.Canvas.TextOut( 20, 80, szData );
        frmDisplay.Canvas.Unlock();
   end;

end;

procedure TfrmMain.InterruptEvent();
begin
    gulIntCounter:=gulIntCounter+1;

end;

procedure TfrmMain.BufChangeEvent();
var
  szData   : AnsiString;
  i        : integer;
  p        : Pointer;
begin

   gulBfChgCounter:=gulBfChgCounter+1;
   gwCyclicCount := gulBfChgCounter div 2;

   // Get DMA transfer status
   ptFAICheck.ActiveBuf := @gwActiveBuf;
   ptFAICheck.stopped   := @gwStopped;
   ptFAICheck.retrieved := @gulRetrieved;
   ptFAICheck.overrun   := @gwOverrun;
   ptFAICheck.HalfReady := @gwHalfReady;

   ErrCde := DRV_FAICheck(DriverHandle,ptFAICheck);

    // When call DRV_FAITransfer( ), the overrun event flag will be cleaned,
    // otherwise, the application will receive overrun event continously.
    // Get real voltage of buffer from driver
    ptFAITransfer.ActiveBuf := 0;   // single buffer
    ptFAITransfer.DataType := gwDataType;

    if ( 2=gwHalfReady ) then
       ptFAITransfer.start := gulConvNum div 2
    else
       ptFAITransfer.start := 0;

    if ( gulConvNum > gwChlNum ) then
       ptFAITransfer.count := gwChlNum // For demo, we only get few data
    else
       ptFAITransfer.count := 1;  // For demo, we only get few data
    ptFAITransfer.overrun  := @gwOverrun;

    ErrCde := DRV_FAITransfer(DriverHandle,ptFAITransfer);
   frmDisplay.Canvas.Lock();
    frmDisplay.Canvas.Font.Color := clBlue;
    p :=ptFAITransfer.DataBuffer;
     for i:=0 to gwChlNum-1 do
    begin
        if ( gwDataType = 1 ) then
        begin
          szData := 'Chan ' + IntToStr( i+gwStartChl );
          szData := szData + ': ';
          szData := szData + FormatFloat('0.00000000',single(p^) );
          Longint(p) := Longint(p) + SizeOf(Single);
        end
        else
        begin
          szData := 'Chan ' + IntToStr( i+gwStartChl );
          szData := szData + ': ';
          szData := szData + IntToHex( Word(p^), 3 );
          Longint(p) := Longint(p) + SizeOf(Word);
       end;
        frmDisplay.Canvas.TextOut( 20, 120+ 15*i, szData );
    end;
    frmDisplay.Canvas.Unlock();
end;


procedure TfrmMain.OverrunEvent();
begin
     gulOverrunCounter:=gulOverrunCounter+1;
    DRV_ClearOverrun(  DriverHandle );

end;

procedure TfrmMain.TerminateEvent();
var
  szData   : AnsiString;
  i        : integer;
  p        : Pointer;
begin
   // Get real voltage of buffer from driver
   ptFAITransfer.ActiveBuf := 0;   // single buffer
   ptFAITransfer.DataType := gwDataType;
   ptFAITransfer.start    := 0;
   ptFAITransfer.count    := gulConvNum;
   ptFAITransfer.overrun  := @gwOverrun;
   ErrCde := DRV_FAIStop(DriverHandle);
    if DoesErr(ErrCde) = 1  then
    begin
      DRV_DeviceClose(DriverHandle);
      Exit;
    end;
   ErrCde := DRV_FAITransfer(DriverHandle, ptFAITransfer);
    if DoesErr(ErrCde) = 1  then
    begin
      DRV_DeviceClose(DriverHandle);
      Exit;
    end;
   // Display data
    frmDisplay.Show();
    frmDisplay.Visible := true;
    frmDisplay.lstBuffer.Clear();
     frmDisplay.lstBuffer.Visible :=true;
    p := ptFAITransfer.DataBuffer;
    for i:=0 to gwChlNum-1 do
    begin
        if ( gwDataType = 1 ) then
        begin
          szData := 'Chan ' + IntToStr( i+gwStartChl );
          szData := szData + ': ';
          szData := szData + FormatFloat('0.00000000',single(p^) );
          Longint(p) := Longint(p) + SizeOf(Single);
        end
        else
        begin
          szData := 'Chan ' + IntToStr( i+gwStartChl );
          szData := szData + ': ';
          szData := szData + IntToHex( Word(p^), 3 );
          Longint(p) := Longint(p) + SizeOf(Word);
       end;
        frmDisplay.lstBuffer.Items.Add(szData);
    end;

   // Free buffer
   GlobalFree(HGLOBAL(hUserBuf));
   GlobalFree(HGLOBAL(hDisplayBuf));
   // Close driver
     ErrCde := DRV_DeviceClose(DriverHandle);
    if DoesErr(ErrCde) = 1  then
    begin
      Exit;
    end;


    butStop.Enabled := false;
    butStart.Enabled := true;
    lstDevice.Enabled := true;
    editScanNum.Enabled := true;
    cmbGain.Enabled := true;
    cmbChannel.Enabled := true;
    butExit.Enabled := true;
    frmDisplay.lstBuffer.Visible :=true;

end;

procedure TfrmMain.butStopClick(Sender: TObject);
var
  szData   : AnsiString;
  i        : integer;
  p        : Pointer;
  ExitCode : DWORD;
begin
   bThreadloop := false;
   Sleep(200);


   if(gwCyclicMode = 1) then
   begin
     GetExitCodeThread(chkThread.Handle,ExitCode);
     if(ExitCode = STILL_ACTIVE) then
         TerminateThread(chkThread.handle,ExitCode);
   end;
   ErrCde := DRV_FAIStop(DriverHandle);
    if DoesErr(ErrCde) = 1  then
    begin
      DRV_DeviceClose(DriverHandle);
      Exit;
    end;
    Sleep(100);

   // Get real voltage of buffer from driver
   ptFAITransfer.ActiveBuf := 0;   // single buffer
   ptFAITransfer.DataType := gwDataType;
   ptFAITransfer.start    := 0;
   ptFAITransfer.count    := gulConvNum;
   ptFAITransfer.overrun  := @gwOverrun;

   ErrCde := DRV_FAITransfer(DriverHandle, ptFAITransfer);
    if DoesErr(ErrCde) = 1  then
    begin
      DRV_DeviceClose(DriverHandle);
      Exit;
    end;
   // Display data
    frmDisplay.Show();
    frmDisplay.lstBuffer.Clear();
    frmDisplay.lstBuffer.Visible :=true;
    p := ptFAITransfer.DataBuffer;
    for i:=0 to gwChlNum-1 do
    begin
        if ( gwDataType = 1 ) then
        begin
          szData := 'Chan ' + IntToStr( i+gwStartChl );
          szData := szData + ': ';
          szData := szData + FormatFloat('0.00000000',single(p^) );
          Longint(p) := Longint(p) + SizeOf(Single);
        end
        else
        begin
          szData := 'Chan ' + IntToStr( i+gwStartChl );
          szData := szData + ': ';
          szData := szData + IntToHex( Word(p^), 3 );
          Longint(p) := Longint(p) + SizeOf(Word);
       end;
        frmDisplay.lstBuffer.Items.Add(szData);
    end;

   // Free buffer
   GlobalFree(HGLOBAL(hUserBuf));
   GlobalFree(HGLOBAL(hDisplayBuf));
   // Close driver
     ErrCde := DRV_DeviceClose(DriverHandle);
    if DoesErr(ErrCde) = 1  then
    begin
      Exit;
    end;


    butStop.Enabled := false;
    butStart.Enabled := true;
    lstDevice.Enabled := true;
    editScanNum.Enabled := true;
    cmbGain.Enabled := true;
    cmbChannel.Enabled := true;
    butExit.Enabled := true;
    frmDisplay.lstBuffer.Visible :=true;

end;

procedure TfrmMain.radCyclicClick(Sender: TObject);
begin
     gwCyclicMode := 1;
end;

procedure TfrmMain.radNonCyclicClick(Sender: TObject);
begin
     gwCyclicMode := 0;

end;

procedure TfrmMain.radRawDataClick(Sender: TObject);
begin
     gwDataType := 0;

end;

procedure TfrmMain.radVoltageClick(Sender: TObject);
begin
     gwDataType := 1;

end;

procedure TfrmMain.radClockInternalClick(Sender: TObject);
begin
    editPacerRate.Enabled := true;
    gwClockSrc := 0;

end;

procedure TfrmMain.radClockExternal0Click(Sender: TObject);
begin
     editPacerRate.Enabled := false;
    gwClockSrc := 1;
end;

procedure TfrmMain.radClockExternal1Click(Sender: TObject);
begin
     editPacerRate.Enabled := false;
    gwClockSrc := 2;
end;

procedure TfrmMain.radInternalClick(Sender: TObject);
begin
        gwExtTrig:=0;

end;

procedure TfrmMain.radExternalClick(Sender: TObject);
begin
        gwExtTrig:=1;

end;

procedure TfrmMain.radRisingClick(Sender: TObject);
begin
    gwTrigEdge:=0;

end;

procedure TfrmMain.radFallingClick(Sender: TObject);
begin
    gwTrigEdge:=1;

end;

procedure TfrmMain.radDigitalClick(Sender: TObject);
begin
   editTrigVolt.Enabled := false;
   gwSRCType := 0;
end;

procedure TfrmMain.radAI0Click(Sender: TObject);
begin
   editTrigVolt.Enabled := true;
   gwSRCType := 1;
end;

procedure TfrmMain.radAI1Click(Sender: TObject);
begin
   editTrigVolt.Enabled := true;
   gwSRCType := 2;
end;

procedure TfrmMain.radAI2Click(Sender: TObject);
begin
   editTrigVolt.Enabled := true;
   gwSRCType := 3;
end;

procedure TfrmMain.radAI3Click(Sender: TObject);
begin
   editTrigVolt.Enabled := true;
   gwSRCType := 4;
end;

procedure TfrmMain.radDelayClick(Sender: TObject);
begin
   editDelayCount.Enabled:=true;
   radFalling.Enabled := true;
   radRising.Enabled := true;
   radDigital.Enabled := true;
   radAI0.Enabled := true;
   radAI1.Enabled := true;
   radAI2.Enabled := true;
   radAI3.Enabled := true;
   radExternal.Checked:=true;
   gwTrigMode:=2;
    gwTrigEdge:=1;
   radFalling.Checked := True;
   radCyclic.Enabled := true;
   radNonCyclic.Enabled := true;

end;

procedure TfrmMain.radAboutClick(Sender: TObject);
begin
   editDelayCount.Enabled:=true;
   radFalling.Enabled := true;
   radRising.Enabled := true;
   radDigital.Enabled := true;
   radAI0.Enabled := true;
   radAI1.Enabled := true;
   radAI2.Enabled := true;
   radAI3.Enabled := true;
   radExternal.Checked:=true;
   gwTrigMode:=3;
   gwTrigEdge:=0;
   radRising.Checked := True;
   radCyclic.Enabled := false;
   radNonCyclic.Enabled := false;



end;

procedure TfrmMain.butExitClick(Sender: TObject);
begin
   Close();
end;

procedure TfrmMain.cmbGainChange(Sender: TObject);
var
   i : integer;
begin
   for i:=0 to 63 do
      gwGain[i] :=  cmbGain.ItemIndex;


end;

end.




