unit formrun;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Driver, Global;

type
  Tfrmrun = class(TForm)
    txtVoltage: TEdit;
    CmdExit: TButton;
    labvolt: TLabel;
    vsclVoltage: TScrollBar;
    labHiVolt: TLabel;
    labLoVolt: TLabel;
    procedure CmdExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure vsclVoltageChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmrun: Tfrmrun;

implementation

uses formstar;

var
   Response       : Integer;
{$R *.DFM}

procedure Tfrmrun.CmdExitClick(Sender: TObject);
begin
     frmRun.Close;
     Formstar.frmstart.Show;
end;

procedure Tfrmrun.FormCreate(Sender: TObject);
begin
  vsclVoltage.Position := 0;
  txtVoltage.Text := IntToStr(0);
end;

procedure Tfrmrun.vsclVoltageChange(Sender: TObject);
var
   lpAOVoltageOut : PT_AOVoltageOut;
       VsclRange  : Longint;
       VolRange   : Single;
       VsclOffset : Longint;
begin
  VolRange := ptAOConfig.MaxValue - ptAOConfig.MinValue;
  VsclRange := vsclVoltage.Max - vsclVoltage.Min;
  VsclOffset := vsclVoltage.Max - vsclVoltage.Position;
  lpAOVoltageOut.chan := ptAOConfig.chan;
  lpAOVoltageOut.OutputValue := VsclOffset / VsclRange * VolRange + ptAOConfig.MinValue;
  ErrCde := DRV_AOVoltageOut(DeviceHandle, lpAOVoltageOut);
  If (ErrCde <> 0) Then
  begin
       DRV_GetErrorMessage(ErrCde, pszErrMsg);
       Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
       DRV_DeviceClose(DeviceHandle);
       Exit;
  end;
  txtVoltage.Text := FloatToStrF((VsclOffset / VsclRange * VolRange + ptAOConfig.MinValue), ffFixed, 5, 2);
end;

end.
