unit formrun;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Driver, Global;

type
  Tfrmrun = class(TForm)
    txtVoltRead: TEdit;
    CmdRead: TButton;
    CmdExit: TButton;
    tmrRead: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    lstTemperatureUnit: TListBox;
    GroupSample: TGroupBox;
    labStart: TLabel;
    labEnd: TLabel;
    hscrFreq: TScrollBar;
    procedure CmdExitClick(Sender: TObject);
    procedure hscrFreqChange(Sender: TObject);
    procedure tmrReadTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CmdReadClick(Sender: TObject);
  private
    { Private declarations }
    ErrCount: Integer;
  public
    { Public declarations }
  end;

var
  frmrun: Tfrmrun;

implementation

uses formstar;

var
   Response       : Integer;
{$R *.DFM}

procedure Tfrmrun.CmdExitClick(Sender: TObject);
begin
     tmrRead.Enabled := True;
     frmRun.Close;
     Formstar.frmstart.Show;
end;

procedure Tfrmrun.hscrFreqChange(Sender: TObject);
begin
     if hscrFreq.Position = 0 then
        tmrRead.Interval := 0
     else
        tmrRead.Interval := trunc(10000 / hscrFreq.Position);
     tmrRead.Enabled := True;
end;

procedure Tfrmrun.tmrReadTimer(Sender: TObject);
var
   fTemp : Single;
begin
    if lstTemperatureUnit.ItemIndex >= 0 then
       ptTCMuxRead.TempScale := lstTemperatureUnit.ItemIndex
    else
       ptTCMuxRead.TempScale := 0;
    ptTCMuxRead.temp      := @fTemp;

    ErrCde := DRV_TCMuxRead(DeviceHandle, ptTCMuxRead);
    If (ErrCde <> 0) Then
    begin
       tmrRead.Enabled := False;
       DRV_GetErrorMessage(ErrCde, pszErrMsg);
       Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
       Exit;
    end;
    txtVoltRead.Text := FloatToStrF(fTemp, ffFixed, 5, 2);
end;

procedure Tfrmrun.FormCreate(Sender: TObject);
begin
     hscrFreq.Position := 10;
     ErrCount := 0;
     tmrRead.Enabled   := False;
     { Add selectable items for temperature unit }
     lstTemperatureUnit.Items.Add('Celsius');
     lstTemperatureUnit.Items.Add('Fahrenheit');
     lstTemperatureUnit.Items.Add('Rankine');
     lstTemperatureUnit.Items.Add('Kelvin');

end;

procedure Tfrmrun.CmdReadClick(Sender: TObject);
var
   fTemp : Single;
begin
    { Disable Timer }
    tmrRead.Enabled := False;

    if lstTemperatureUnit.ItemIndex >= 0 then
       ptTCMuxRead.TempScale := lstTemperatureUnit.ItemIndex
    else
       ptTCMuxRead.TempScale := 0;
    ptTCMuxRead.temp      := @fTemp;

    ErrCde := DRV_TCMuxRead(DeviceHandle, ptTCMuxRead);
    If (ErrCde <> 0) Then
    begin
       DRV_GetErrorMessage(ErrCde, pszErrMsg);
       Response := Application.MessageBox(pszErrMsg, 'Error!!', MB_OK);
       Exit;
    end;
    txtVoltRead.Text := FloatToStrF(fTemp, ffFixed, 5, 2);
end;

end.
