Attribute VB_Name = "mdlGlobal"
Option Explicit
'function declare
Public Declare Function CreateThread Lib "kernel32" (ByVal lpThreadAttributes As Long, ByVal dwStackSize As Long, lpStartAddress As Long, lpParameter As Any, ByVal dwCreationFlags As Long, lpThreadId As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function ResumeThread Lib "kernel32" (ByVal hThread As Long) As Long
Public Declare Function SetThreadPriority Lib "kernel32" (ByVal hThread As Long, ByVal nPriority As Long) As Long


'const flag
Public Const CREATE_SUSPENDED = &H4

Global Const MaxEntries = 255
Global DeviceHandle As Long
Global devicelist(0 To MaxEntries) As PT_DEVLIST
Global ErrCde As Long
Global szErrMsg As String * 80
Global bRun As Boolean          'if counter is runing

'
Public Type SWAVE
    nWaveform As Integer
    dbMagnitude As Single
    dbOffset As Single
    nPeriod As Integer
End Type
Global ptFAOScale As PT_FAOScale
Global ptFAOWaveFormStart As PT_FAOWaveFormStart
Global ptEnableEvent As PT_EnableEvent
Global ptFAOCheck As PT_FAOCheck
Global ptCheckEvent As PT_CheckEvent
'const
Global ADV_CHANNEL(0 To 3) As Integer   'used as const
Global Const INFINITE As Long = &HFFFFFFFF
Global Const WAVE_SINE As Integer = 0
Global Const WAVE_TRIANGLE As Integer = 1
Global Const WAVE_SQUARE As Integer = 2
Global Const SINE_TRIANGLE As Integer = 3


Global nDevice As Integer       'device number
Global gbSelectDevice As Boolean 'device is selected?
Global gszDescription As String * 80 'device description
Global glWaveFormCount As Long  'wave count
Global gbEventEnable As Integer 'event enable, 1 for enable
Global gbTrigger As Integer     '1 for internal, 0 for external trigger source
Global glPacerRate As Long      'pacer rate
Global glConvNum As Long        'conversion number
Global gSWave(0 To 3) As SWAVE
Global lpCommBuffer() As Integer
Global lpBuffer() As Integer        'buffer used by driver
Global lpVolBuffer() As Single   'buffer for real voltage
Global glEnabledChannel As Long, glChannelCount As Long
Global hThreadHandle As Long, glThreadID As Long            'user thread
Global gbThreadLoop As Integer                              'thread is runing
Global gbThreadFlag As Boolean
Global glActiveBuffer As Long, glStopped As Long, glCurrentCount As Long
Global glHalfReady As Long, glOverRun As Long

Public Function uShowErrMsg() As Integer
    DRV_GetErrorMessage ErrCde, szErrMsg
    uShowErrMsg = MsgBox(szErrMsg, vbOKOnly, "Error!")
End Function

Public Sub UserThread()
'NOTES:
'1. Do not try to set breakpoint in EvenThread(), this will crash the IDE.
'2. Use "Debug.Print" or something else to trace the thread
'3. Because multi-thread programming was not be well-supported in Visual Basic,
'   debug this sample may often crash the IDE. So you'd better compile this sample
'   to a executable file and run it if you want to see the result.
    Dim lEventType As Long
    While (gbThreadLoop = 1)
        ptCheckEvent.EventType = DRV_GetAddress(lEventType)
        ptCheckEvent.Milliseconds = 1000
        gbThreadFlag = True
        ErrCde = DRV_CheckEvent(DeviceHandle, ptCheckEvent)
        If (ErrCde <> 0) Then
            uShowErrMsg
            gbThreadLoop = 0
        End If
        'Process interrupt event
        If ((lEventType And ADS_EVT_INTERRUPT) <> 0) Then
            Debug.Print "Interrupt Event"
        End If
        'Process overrun event
        If ((lEventType And ADS_EVT_OVERRUN) <> 0) Then
            Debug.Print "OverRun Event"
        End If
        'Process terminate event
        If ((lEventType And ADS_EVT_TERMINATED) <> 0) Then
            Debug.Print "Terminated Event"
        End If
        gbThreadFlag = False
    Wend
End Sub
