Attribute VB_Name = "Module2"
Option Explicit
Const MaxEntries = 255
Global DeviceHandle As Long
Global ptDevGetFeatures As PT_DeviceGetFeatures
Global lpDevFeatures As DEVFEATURES
Global devicelist(0 To MaxEntries) As PT_DEVLIST
Global SubDevicelist(0 To MaxEntries) As PT_DEVLIST
Global ErrCde As Long
Global szErrMsg As String * 80
Global lpAIConfig As PT_AIConfig
Global AiVolIn As PT_AIVoltageIn
Global ptAIGetConfig As PT_AIGetConfig
Global AiCtrMode As Integer
Global lGainCode(0 To 15) As Long
Global iGainIndex(0 To 15) As Integer
Global dfCurDevice As DEVFEATURES
Global gnNumOfSubdevices As Integer
Global Response As Integer
Global ptDmaBuffer As PT_AllocateDMABuffer
Global lActualBufSize As Long
Global glDmaBufPtr As Long
Global giConvCount As Integer
Global gwavOut As WAVE_PROPERTY  '{used in Init.pas & Waveform.pas}
Global gpBinOutBuf As Long
Global glConversionCounts As Long
Global BinOutBuf() As Long
Global fWaveBuf() As Single

Type WAVE_PROPERTY
    iType      As Integer     '{0: Sine, 1: Triangle, 2: Square}
    fMagnitude As Single
    fOffset    As Single
    lPeriod    As Long
End Type

Public Function MakeWaveForm(lCount As Long)
Dim l As Long
Dim fSlope As Single
Dim lHalf As Long, lNow As Long

Select Case gwavOut.iType
       Case 0 '{Sine}
        For l = 0 To lCount - 1
            fWaveBuf(l) = gwavOut.fMagnitude * Sin(6.28318 * l / gwavOut.lPeriod) + gwavOut.fOffset
        Next l

       Case 1 '{Triangle}
        fSlope = gwavOut.fMagnitude * 4# / gwavOut.lPeriod
        lHalf = gwavOut.lPeriod / 2

        For l = 0 To lCount - 1
          lNow = l Mod gwavOut.lPeriod
          If lNow <= lHalf Then
            fWaveBuf(l) = fSlope * lNow - gwavOut.fMagnitude + gwavOut.fOffset
          Else
            fWaveBuf(l) = fSlope * (gwavOut.lPeriod - lNow) - gwavOut.fMagnitude + gwavOut.fOffset
          End If
        Next l

       Case 2 '{Square}
        lHalf = gwavOut.lPeriod / 2
        For l = 0 To lCount - 1
          lNow = l Mod gwavOut.lPeriod
          If lNow <= lHalf Then
             fWaveBuf(l) = gwavOut.fOffset - gwavOut.fMagnitude
          Else
             fWaveBuf(l) = gwavOut.fOffset + gwavOut.fMagnitude
          End If
        Next l
End Select
End Function

Public Function ChkErr(ByVal lErrCde As Long) As Long
    If (lErrCde <> 0) Then
        DRV_GetErrorMessage lErrCde, szErrMsg
        Response = MsgBox(szErrMsg, vbOKOnly, "Error!!")
        ChkErr = 1
    Else
        ChkErr = 0
    End If
End Function








