VERSION 5.00
Begin VB.Form formFout 
   Caption         =   "Fout"
   ClientHeight    =   3105
   ClientLeft      =   5640
   ClientTop       =   4950
   ClientWidth     =   6015
   LinkTopic       =   "Form1"
   ScaleHeight     =   3105
   ScaleWidth      =   6015
   Begin VB.CommandButton btnExit 
      Caption         =   "Exit"
      Height          =   435
      Left            =   4680
      TabIndex        =   8
      Top             =   2280
      Width           =   1095
   End
   Begin VB.CommandButton btnStop 
      Caption         =   "Stop"
      Height          =   435
      Left            =   2520
      TabIndex        =   7
      Top             =   2280
      Width           =   1095
   End
   Begin VB.CommandButton btnStart 
      Caption         =   "Start"
      Height          =   435
      Left            =   240
      TabIndex        =   6
      Top             =   2280
      Width           =   1095
   End
   Begin VB.Frame frmDivider 
      Caption         =   "Divider"
      Height          =   855
      Left            =   4560
      TabIndex        =   5
      Top             =   1200
      Width           =   1335
      Begin VB.ComboBox cmbDivider 
         Height          =   315
         ItemData        =   "Fout.frx":0000
         Left            =   120
         List            =   "Fout.frx":003A
         TabIndex        =   11
         Text            =   "1"
         Top             =   360
         Width           =   975
      End
   End
   Begin VB.Frame frmFoutSrc 
      Caption         =   "FoutSrc"
      Height          =   855
      Left            =   2430
      TabIndex        =   4
      Top             =   1200
      Width           =   1335
      Begin VB.ComboBox cmbFoutSrc 
         Height          =   315
         ItemData        =   "Fout.frx":0075
         Left            =   120
         List            =   "Fout.frx":0091
         TabIndex        =   10
         Text            =   "10KHZ"
         Top             =   360
         Width           =   975
      End
   End
   Begin VB.Frame frmChannel 
      Caption         =   "Channel"
      Height          =   855
      Left            =   150
      TabIndex        =   3
      Top             =   1200
      Width           =   1335
      Begin VB.ComboBox cmbChannel 
         Height          =   315
         ItemData        =   "Fout.frx":00D8
         Left            =   120
         List            =   "Fout.frx":00E8
         TabIndex        =   9
         Text            =   "0"
         Top             =   360
         Width           =   975
      End
   End
   Begin VB.Frame frmDeviceSelection 
      Caption         =   "Device Selection"
      Height          =   735
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   5775
      Begin VB.CommandButton btnSelectDevice 
         Caption         =   "Select Device"
         Height          =   375
         Left            =   4080
         TabIndex        =   2
         Top             =   240
         Width           =   1455
      End
      Begin VB.Label labDeviceName 
         Height          =   255
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   3855
      End
   End
End
Attribute VB_Name = "formFout"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim ptDevFeatures As DEVFEATURES         ' structure for device features
Dim ptDevGetFeatures As PT_DeviceGetFeatures
Dim ptFreqOutStart As PT_FreqOutStart

Public DeviceNum As Long
Public DriverHandle As Long
Public ErrorNum As Long

Public bRun As Boolean

Private Sub btnExit_Click()
   End
End Sub

Private Sub btnSelectDevice_Click()
   Dim Description As String

   Description = String(80, vbNullChar)
   ErrorNum = DRV_SelectDevice(hWnd, False, DeviceNum, Description)
   labDeviceName.Caption = Description
   bRun = False
End Sub

Private Sub btnStart_Click()
   ErrorNum = DRV_DeviceOpen(DeviceNum, DriverHandle)
   If CheckError(ErrorNum) <> 0 Then
      Exit Sub
   End If

   ptDevGetFeatures.buffer = DRV_GetAddress(ptDevFeatures)
   'ptDevGetFeatures.size = sizeof(DEVFEATURES)

   ErrorNum = DRV_DeviceGetFeatures(DriverHandle, ptDevGetFeatures)
   If CheckError(ErrorNum) <> 0 Then
      DRV_DeviceClose (DriverHandle)
      Exit Sub
   End If

   ' check number of counter channels
   If ptDevFeatures.usMaxTimerChl = 0 Then
      MsgBox "No Counter Channel", vbInformation, "Driver Message"
      DRV_DeviceClose (DriverHandle)
      Exit Sub
   End If
   
   'start Fout
   
   Select Case cmbFoutSrc.Text
          Case "External Clock"
          ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_EXTER_CLK
          Case "CLK N"
          ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_CLK_N
          Case "FOUT N-1"
          ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_FOUT_N_M1
          Case "10MHZ"
          ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_CLK_10MHZ
          Case "1MHZ"
          ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_CLK_1MHZ
          Case "100KHZ"
          ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_CLK_100KHZ
          Case "10KHZ"
          ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_CLK_10KHZ
          Case "1KHZ"
          ptFreqOutStart.usFoutSrc = PA_FOUT_SRC_CLK_1KHZ
    End Select
          ptFreqOutStart.usChannel = Val(cmbChannel.Text)
          ptFreqOutStart.usDivider = Val(cmbDivider.Text)
          
          ErrorNum = DRV_FreqOutStart(DriverHandle, ptFreqOutStart)
          If CheckError(ErrorNum) <> 0 Then
             DRV_DeviceClose (DriverHandle)
             Exit Sub
          End If
          
          frmDeviceSelection.Enabled = False
          frmChannel.Enabled = False
          frmFoutSrc.Enabled = False
          frmDivider.Enabled = False
          btnStart.Enabled = False
          btnExit.Enabled = False
          btnStop.Enabled = True
          bRun = True
             
End Sub

Private Sub btnStop_Click()
    Dim inChannel As Integer
    inChannel = Val(cmbChannel.Text)
    ErrorNum = DRV_FreqOutReset(DriverHandle, inChannel)
    ErrorNum = DRV_DeviceClose(DriverHandle)
    
    frmDeviceSelection.Enabled = True
    frmChannel.Enabled = True
    frmFoutSrc.Enabled = True
    frmDivider.Enabled = True
    btnStart.Enabled = True
    btnExit.Enabled = True
    btnStop.Enabled = False
    bRun = False
    
End Sub

Private Sub Form_Load()
   Dim Description As String

   Description = String(80, vbNullChar)
   ErrorNum = DRV_SelectDevice(hWnd, False, DeviceNum, Description)
   labDeviceName.Caption = Description
End Sub

Public Function CheckError(ByVal lErrCde As Long) As Boolean
   Dim szErrMsg As String * 80

   If (lErrCde <> 0) Then
      DRV_GetErrorMessage lErrCde, szErrMsg
      Response = MsgBox(szErrMsg, vbOKOnly, "Error!!")
      CheckError = True
   Else
      CheckError = False
   End If
End Function


Private Sub Form_Terminate()
    If (bRun = True) Then
      Call btnStop_Click
    End If
      
End Sub
