// ############################################################################
// ****************************************************************************
//              Copyright (C) 2000-2, Advantech Automation Corp.
//      THIS IS AN UNPUBLISHED WORK CONTAINING CONFIDENTIAL AND PROPRIETARY
//         INFORMATION WHICH IS THE PROHERTY OF ADVANTECH AUTOMATION CORP.
// 
//   ANY DISCLOSURE, USE, OR REPRODUCTION, WITHOUT WRITTEN AUTHORIZATION FROM
//             ADVANTECH AUTOMATION CORP., IS STRICTLY PROHIBITED
// ****************************************************************************
// ############################################################################
// 
// File:        COUNTER.c
// Created:     08/19/2002
// Description: Demo program for event counting
// ----------------------------------------------------------------------------

#include <windows.h>
#include <stdlib.h>
#include <dos.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include "..\..\..\..\include\driver.h"
#include "resource.h"

// ------------------------------------------------------------------------
// CONSTANT DEFINITION
// ------------------------------------------------------------------------
#define     MAX_DEVICES     100
#define     MAX_CNT_NUM      8
#define     ADS_EVT_NUM      9

// ------------------------------------------------------------------------
// GLOBAL VARIABLES
// ------------------------------------------------------------------------
HANDLE      hInst;                      // current instance
HWND        hMainWnd;                   // main window handle

HDC         hdc;
RECT        rect;

static      DEVFEATURES          DevFeatures;    // structure for device features
static      PT_CounterEventStart ptCounterEventStart;
static      PT_CounterEventRead  ptCounterEventRead;
static      PT_DeviceGetFeatures ptDevFeatures;
static      PT_CounterConfig     ptCounterConfig;
static      PT_EnableEvent       ptEnableEvent;
static      PT_CheckEvent        ptCheckEvent;      // Check event 

char        szErrMsg[80];               // Use for MESSAGEBOX function
LRESULT     ErrCde;                     // Return error code

//
// used for fixed memory for the installed devices
//
DEVLIST     DeviceList[MAX_DEVICES];
DEVLIST     SubDeviceList[MAX_DEVICES];

LONG        DriverHandle = (LONG)NULL;          // driver handle
BOOL        bRun = FALSE;                       // flag for running
USHORT      gwDevice = 0, gwSubDevice = 0;      // device index
USHORT      gwOverflow  = 0;                    // counter over 32 bit flag
ULONG       gdwReading  = 0;                    // read counter data
ULONG       gwIntCount  = 0;
SHORT       gnNumOfDevices, gnNumOfSubdevices;  // number of installed devices
USHORT      gwChannel = 0;                      // only one counter
LONG        g_usIniVal =65535;                  // number of the initial value of the counter
USHORT      gwScanTime = 1000;                  // scan time
DWORD       gdwStartTime;                       // start time
DWORD       gdwElapseTime = 0;                  // elapse time
USHORT      gwOverrunCount = 0;                 // overrun count
FARPROC     lpfnConfigDlgProc;                  // config. dialog procedure
FARPROC     lpfnScanDlgProc;                    // scan dialog procedure
static  USHORT gwIntFlag  = 0;                  // interrupt enable(0)
static  USHORT gwOutputMode  = 2;               // defautl output mode(TC OUTPUT) 
static  USHORT gwGateSrc     = 3;               // default gate source(NO Gating)
static  USHORT gwClkSrc      = 0;               // default count source(IDI0)

UINT        gwCount       = 1;                  // number of interrupt event count

HANDLE      hThreadHandle;
DWORD       dwThreadID = 0x00;
//BOOL        bThreadflag = FALSE;
BOOL        bThreadloop = FALSE;
void UserThread();
// ------------------------------------------------------------------------
// FUNCTION DECLARATION
// ------------------------------------------------------------------------
BOOL InitApplication(HANDLE);
BOOL InitInstance(HANDLE, int);
long FTYPE MainWndProc(HWND, UINT, WPARAM, LPARAM);
int  FTYPE WinMain(HANDLE, HANDLE, LPSTR, int);


/***************************************************************************
    FUNCTION: WinMain(HANDLE, HANDLE, LPSTR, int)

    PURPOSE: calls initialization function, processes message loop
****************************************************************************/

int FTYPE WinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow)
HANDLE hInstance;                          /* current instance             */
HANDLE hPrevInstance;                      /* previous instance            */
LPSTR lpCmdLine;                           /* command line                 */
int nCmdShow;                              /* show-window type (open/icon) */
{
    MSG msg;                               /* message                      */

    if (!hPrevInstance)                /* Other instances of app running?  */
      if (!InitApplication(hInstance)) /* Initialize shared things         */
          return (FALSE);              /* Exits if unable to initialize    */

    // Perform initializations that apply to a specific instance
    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);

    // Acquire and dispatch messages until a WM_QUIT message is received.
    while (GetMessage(&msg,      /* message structure                      */
        (HWND)NULL,              /* handle of window receiving the message */
        (UINT)NULL,              /* lowest message to examine              */
        (UINT)NULL))             /* highest message to examine             */
    {
        TranslateMessage(&msg);  /* Translates virtual key codes           */
        DispatchMessage(&msg);   /* Dispatches message to window           */
    }
    return (msg.wParam);         /* Returns the value from PostQuitMessage */
}

/****************************************************************************
    FUNCTION: InitApplication(HANDLE)

    PURPOSE: Initializes window data and registers window class
****************************************************************************/

BOOL InitApplication(hInstance)
HANDLE hInstance;                            /* current instance           */
{
    WNDCLASS  wc;

    // Fill in window class structure with parameters that describe the
    // main window.
    wc.style = CS_HREDRAW | CS_VREDRAW; /* Class style(s).                 */
    wc.lpfnWndProc = (WNDPROC)MainWndProc;   /* window process procedure   */
    wc.cbClsExtra = 0;                  /* No per-class extra data.        */
    wc.cbWndExtra = 0;                  /* No per-window extra data.       */
    wc.hInstance = hInstance;           /* Application that owns the class.*/
    wc.hIcon = LoadIcon(hInstance, "IDI_ICON1");
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName =  "MyMenu";   /* Name of menu resource in .RC file.  */
    wc.lpszClassName = "MyClass";  /* Name used in call to CreateWindow. */

    // Register the window class and return success/failure code.
    return (RegisterClass(&wc));

}

/***************************************************************************
    FUNCTION:  InitInstance(HANDLE, int)

    PURPOSE:  Saves instance handle and creates main window
****************************************************************************/

BOOL InitInstance
(
    HANDLE          hInstance,          // Current instance identifier.
    int             nCmdShow            // Param for first ShowWindow() call.
)
{
    // Save the instance handle in static variable, which will be used in
    // many subsequence calls from this application to Windows.
    hInst = hInstance;

    // Create a main window for this application instance.
    hMainWnd = CreateWindow(
        "MyClass",                 /* See RegisterClass() call.           */
        "Advantech Driver Demo : Event Counter" , /* Window title bar  */
        WS_OVERLAPPEDWINDOW,        /* Window style.                       */
        CW_USEDEFAULT,              /* Default horizontal position.        */
        CW_USEDEFAULT,              /* Default vertical position.          */
        CW_USEDEFAULT,              /* Default width.                      */
        CW_USEDEFAULT,              /* Default height.                     */
        NULL,                       /* Overlapped windows have no parent.  */
        NULL,                       /* Use the window class menu.          */
        hInstance,                  /* This instance owns this window.     */
        NULL                        /* Pointer not needed.                 */
        );

    // If window could not be created, return "failure"
    if (!hMainWnd)
        return (FALSE);

    // Make the window visible; update its client area; and return "success"

    ShowWindow(hMainWnd, nCmdShow);   // Show the window
    UpdateWindow(hMainWnd);           // Sends WM_PAINT message
    return (TRUE);                // Returns the value from PostQuitMessage
}

/***************************************************************************
    FUNCTION: ConfigDlgProc(HWND, unsigned, WPARAM, LPARAM)

    PURPOSE:  Processes dialog box messages for configuration
****************************************************************************/

BOOL FTYPE ConfigDlgProc
(
    HWND        hDlg,                          // window handle
    unsigned    message,                       // type of message
    WPARAM      wParam,                        // additional information
    LPARAM      lParam                         // additional information
)
{
    int         i;
    DWORD       dwIndex;
    char        szBuffer[40];
    int         nOutEntries;

    switch (message)
    {
    case WM_INITDIALOG :

        // --------------------------------
        // Initialize Device List Combobox
        // --------------------------------

        // get number of the installed devices
        if ((ErrCde = DRV_DeviceGetNumOfList((SHORT far *)&gnNumOfDevices)) !=
            SUCCESS)
        {
             DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
             MessageBox(hMainWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
             return TRUE;
        }


        // ----------------------------------------------------------------
        // used for dynamic allocation memory for these installed devices
        //
        // if ((hDeviceList = GlobalAlloc(GHND, gnNumOfDevices *
        //      sizeof(DEVLIST))) == NULL)
        // {
        //    MessageBox(hMainWnd, (LPCSTR)"Not Enough Memory",
        //        "Memory Allocation", MB_OK);
        //    return TRUE;
        // }
        // DeviceList = (LPDEVLIST)GlobalLock(hDeviceList);
        // ----------------------------------------------------------------


        if (gnNumOfDevices > MAX_DEVICES)
            gnNumOfDevices = MAX_DEVICES;

        // retrieve the information of all installed devices

        if ((ErrCde = DRV_DeviceGetList((DEVLIST far *)&DeviceList[0],
            (SHORT)gnNumOfDevices, (SHORT far *)&nOutEntries)) != (LONG)SUCCESS)
        {
            DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
            MessageBox(hMainWnd,(LPCSTR)szErrMsg,"Driver Message",MB_OK);
            return TRUE;
        }

        // initialize the Device List Combobox with the retrieved information

        for (i = 0; i < gnNumOfDevices; i ++)
            SendDlgItemMessage(hDlg, IDC_DEVICE, CB_ADDSTRING, 0,
                        (LPARAM)((LPSTR)DeviceList[i].szDeviceName));

        SendDlgItemMessage(hDlg, IDC_DEVICE, CB_SETCURSEL,(WPARAM)gwDevice,
                        (LPARAM)0);


        // -----------------------------------------------------------
        // Initialize Module List Combobox for COM port or CAN devices
        // -----------------------------------------------------------

        // check if there is any device attached on this COM port or CAN

        gnNumOfSubdevices = DeviceList[gwDevice].nNumOfSubdevices;
        if (gnNumOfSubdevices > MAX_DEVICES)
            gnNumOfSubdevices = MAX_DEVICES;


        // --------------------------------------------------------------
        // used for dynamic allocation memory for these installed devices
        //
        // if ((hSubDeviceList = GlobalAlloc(GHND, gnNumOfSubdevices *
        //    sizeof(DEVLIST))) == NULL)
        // {
        //    MessageBox(hMainWnd, (LPCSTR)"Not Enough Memory",
        //        "Memory Allocation", MB_OK);
        //    return TRUE;
        // }
        //
        // SubDeviceList = (LPDEVLIST)GlobalLock(hSubDeviceList);
        // --------------------------------------------------------------


        // retrieve the information of all installed devices
        if (gnNumOfSubdevices != 0)
        {
            if ((ErrCde = DRV_DeviceGetSubList(
                (DWORD)DeviceList[gwDevice].dwDeviceNum,
                (DEVLIST far *)&SubDeviceList[0],
                (SHORT)gnNumOfSubdevices,
                (SHORT far *)&nOutEntries)) != (LONG)SUCCESS)
            {
                DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                MessageBox(hMainWnd,(LPCSTR)szErrMsg,"Driver Message",MB_OK);
                return TRUE;
            }


            // initialize the Module List Combobox with the retrieved
            // information

            EnableWindow(GetDlgItem(hDlg, IDC_MODULE), TRUE);
            SendDlgItemMessage(hDlg, IDC_MODULE, CB_RESETCONTENT, 0,
                    (LPARAM)((LPSTR)0));

            for (i = 0; i < gnNumOfSubdevices; i++)
                SendDlgItemMessage(hDlg, IDC_MODULE, CB_ADDSTRING, 0,
                        (LPARAM)((LPSTR)SubDeviceList[i].szDeviceName));

            SendDlgItemMessage(hDlg, IDC_MODULE, CB_SETCURSEL,
					(WPARAM)gwSubDevice, (LPARAM)0);
        }
        else
        {
            EnableWindow(GetDlgItem(hDlg, IDC_MODULE), FALSE);
            SendDlgItemMessage(hDlg, IDC_MODULE, CB_RESETCONTENT, 0,
                    (LPARAM)((LPSTR)0));
        }

		  // initial counter value		 
        itoa(g_usIniVal, szBuffer, 10);
        SendDlgItemMessage(hDlg, IDC_CntIniVal, EM_REPLACESEL, 0,
            (LPARAM)((LPSTR)szBuffer));
        /*
		  // initial count output 		          
 		  if ( gwOutputEnable )
		  {
           CheckRadioButton( hDlg,IDC_OutputEnable,IDC_OutputDisable,IDC_OutputEnable );
		  }
        else
		  {
           CheckRadioButton( hDlg,IDC_OutputEnable,IDC_OutputDisable,IDC_OutputDisable );
           EnableWindow( GetDlgItem( hDlg,IDC_OUTMODE ), FALSE );
		  }
        */
		  // initial output mode
        SendDlgItemMessage(
		     hDlg,
		     IDC_OUTMODE,
		     CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"OUTPUT DISABLE"));
        
        SendDlgItemMessage(
		     hDlg,
		     IDC_OUTMODE,
		     CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"TPGGLED FROM LOW"));

        SendDlgItemMessage(
		     hDlg,
		     IDC_OUTMODE,
		     CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"TC OUTPUT"));
		  
		  SendDlgItemMessage(
		     hDlg,
		     IDC_OUTMODE,
		     CB_SETCURSEL,
		     //gwOutputModeIndex,
           gwOutputMode,
		     0);

		  // initial count source
		  SendDlgItemMessage(
	        hDlg,
			  IDC_CntClkSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"IDI0"));
		  
		  SendDlgItemMessage(
	        hDlg,
			  IDC_CntClkSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"1 MHz"));
		  		  
		  SendDlgItemMessage(
	        hDlg,
			  IDC_CntClkSrc,
	        CB_SETCURSEL,
		     //gwClkSrcIndex,
           gwClkSrc,
		     0);  
	  
		  // initial count interrupt
        CheckRadioButton(hDlg, IDC_IntEnable, IDC_IntDisable,
           (gwIntFlag)?IDC_IntEnable:IDC_IntDisable );
		  
        SendDlgItemMessage(
	        hDlg,
			  IDC_GateSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"GATING"));

		  SendDlgItemMessage(
	        hDlg,
			  IDC_GateSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"IDI16 AS GATE HIGH"));

		  SendDlgItemMessage(
	        hDlg,
			  IDC_GateSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"IDI16 AS GATE LOW"));

		  SendDlgItemMessage(
	        hDlg,
			  IDC_GateSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"NO GATING"));
		  
		  SendDlgItemMessage(
	        hDlg,
			  IDC_GateSrc,
	        CB_SETCURSEL,
		     //gwGateSrcIndex,
           gwGateSrc,
		     0);

      return TRUE;

    case WM_COMMAND :
         switch (LOWORD(wParam))
         {  			
			case IDOK :
            {
              //
              // get device selection
              //
              if ((dwIndex = SendDlgItemMessage(hDlg, IDC_DEVICE,
                           CB_GETCURSEL, 0, 0)) != CB_ERR)
                   gwDevice = (WORD)dwIndex;

              //
              // get sub-device selection
              //
              if ((dwIndex = SendDlgItemMessage(hDlg, IDC_MODULE,
                           CB_GETCURSEL, 0, 0)) != CB_ERR)
                   gwSubDevice = (WORD)dwIndex;

             // get output mode
			   gwOutputMode = (USHORT)SendDlgItemMessage(
					           hDlg, 
							     IDC_OUTMODE, 
							     CB_GETCURSEL,
							     0,
							     (LPARAM)0 );
				// if output disable, gwOutputModeIndex = 0;
           /*
			  if (EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), FALSE ))
           {
					gwGateSrc = 0; // gating
				}
				else // get  gate source				
				{
            */
					gwGateSrc = (USHORT)SendDlgItemMessage(
					                         hDlg, 
							                   IDC_GateSrc, 
							                   CB_GETCURSEL,
							                   0,
							                   (LPARAM)0 );

				//}
					
            // get clock source
				gwClkSrc = (USHORT)SendDlgItemMessage(
				                   hDlg, 
						             IDC_CntClkSrc, 
						             CB_GETCURSEL,
						             0,
						             (LPARAM)0 );
            }
            
				case IDCANCEL :
                 EndDialog(hDlg, 0);
                 return TRUE;

/*
				case IDC_OutputEnable:
               EnableWindow(GetDlgItem(hDlg, IDC_OUTMODE), TRUE);
					gwOutputEnable = PA_MODE_ENABLE_OUTPUT;
               break;
					
				case IDC_OutputDisable:
               EnableWindow(GetDlgItem(hDlg, IDC_OUTMODE), FALSE);
					gwOutputEnable = PA_MODE_DISABLE_OUTPUT;
               break;
*/
         case  IDC_IntEnable:
					gwIntFlag = 1;
					break;
					
			case  IDC_IntDisable:
					gwIntFlag = 0;

			case  IDC_CntIniVal :
               if ( HIWORD(wParam) == EN_KILLFOCUS )
					{
                  if(SendDlgItemMessage(hDlg, IDC_CntIniVal,
                      EM_GETMODIFY, 0, 0))
						 {
                       SendDlgItemMessage(hDlg, IDC_CntIniVal,
                          WM_GETTEXT, 10, (LPARAM)(LPSTR)szBuffer) ;                       
					        g_usIniVal = atol(szBuffer);
                       SendDlgItemMessage(hDlg, IDC_CntIniVal,
                          EM_SETMODIFY, FALSE, 0) ;
						 }

				       if ( ( g_usIniVal <= 0 )||( g_usIniVal > 65535 ))
                   {
					       MessageBox( hDlg, "Invalid Counter Terminate Value", 
						    "Notice", MB_OK );
                      g_usIniVal = 65535;
                      itoa(g_usIniVal, szBuffer, 10);
                      SendDlgItemMessage(hDlg, IDC_CntIniVal, EM_UNDO, 0,
                         (LPARAM)((LPSTR)szBuffer));
					       return TRUE;
                   }
               }
               return TRUE;
					
            case IDC_DEVICE :

                //
                // When device selection is changed, it needs to
                // re-initialize sub-device combobox and input range
                // combobox.
                //

                if (HIWORD(wParam) == CBN_SELCHANGE)
                {
                    if ((dwIndex = SendDlgItemMessage(hDlg, IDC_DEVICE,
                        CB_GETCURSEL, 0, 0)) != CB_ERR)
                         gwDevice = (WORD)dwIndex;
                    else
                        return TRUE;


                    // ------------------------------------------------------
                    // Initialize Module Combobox for COM port or CAN devices
                    // ------------------------------------------------------

                    // check any device attached on this COM port or CAN

                    gnNumOfSubdevices = DeviceList[gwDevice].nNumOfSubdevices;
                    if (gnNumOfSubdevices > MAX_DEVICES)
                        gnNumOfSubdevices = MAX_DEVICES;


                    // retrieve the information of all installed devices

                    if (gnNumOfSubdevices != 0)
                    {
                        if ((ErrCde = DRV_DeviceGetSubList(
                            (DWORD)DeviceList[gwDevice].dwDeviceNum,
                            (DEVLIST far *)&SubDeviceList[0],
                            (SHORT)gnNumOfSubdevices,
                            (SHORT far *)&nOutEntries)) != (LONG)SUCCESS)
                        {
                            DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                            MessageBox(hMainWnd, (LPCSTR)szErrMsg,
                                "Driver Message", MB_OK);
                            return TRUE;
                        }


                        // initialize the Module List Combobox with the
                        // retrieved information

                        EnableWindow(GetDlgItem(hDlg, IDC_MODULE), TRUE);
                        SendDlgItemMessage(hDlg, IDC_MODULE, CB_RESETCONTENT,
                            0, (LPARAM)((LPSTR)0));

                        for (i = 0; i < gnNumOfSubdevices; i++)
                            SendDlgItemMessage(hDlg, IDC_MODULE, CB_ADDSTRING, 0,
                                (LPARAM)((LPSTR)SubDeviceList[i].szDeviceName));

                        gwSubDevice = 0;

                        SendDlgItemMessage(hDlg, IDC_MODULE, CB_SETCURSEL,
							(WPARAM)gwSubDevice, (LPARAM)0);
                    }
                    else
                    {
                        EnableWindow(GetDlgItem(hDlg, IDC_MODULE), FALSE);
                        SendDlgItemMessage(hDlg, IDC_MODULE, CB_RESETCONTENT,
                            0, (LPARAM)((LPSTR)0));
                    }
                }

                return TRUE;
         }

         break;
    }

    return FALSE ;
}


/***************************************************************************
    FUNCTION: ScanDlgProc(HWND, unsigned, WPARAM, LPARAM)

    PURPOSE:  Processes dialog box messages for scan time settings
****************************************************************************/

BOOL FTYPE ScanDlgProc
(
    HWND        hDlg,                          // window handle
    unsigned    message,                       // type of message
    WPARAM      wParam,                        // additional information
    LPARAM      lParam                         // additional information
)
{
    char        szBuffer[40];

    switch (message)
    {
    case WM_INITDIALOG :

        // ---------------------------------------------------
        // Initialize Scan Time Edit, Maximum accuracy: 40 ms
        // ---------------------------------------------------

        itoa(gwScanTime, szBuffer, 10);
        SendDlgItemMessage(hDlg, IDC_SCAN, EM_REPLACESEL, 0,
                        (LPARAM)((LPSTR)szBuffer));

        return TRUE;

    case WM_COMMAND :

         switch (LOWORD(wParam))
         {
            case IDOK :

                //
                // get scan time
                //

                if (SendDlgItemMessage(hDlg, IDC_SCAN,
                           EM_GETMODIFY, 0, 0))
                {
                    SendDlgItemMessage(hDlg, IDC_SCAN,
                            WM_GETTEXT, 10, (LPARAM)(LPSTR)szBuffer) ;
                    gwScanTime = atoi(szBuffer);
                    SendDlgItemMessage(hDlg, IDC_SCAN,
                              EM_SETMODIFY, FALSE, 0) ;
                }

            case IDCANCEL :
                EndDialog(hDlg, 0);
                return TRUE;

         }
         break;
    }
    return FALSE ;
}


/***************************************************************************
    FUNCTION: MainWndProc(HWND, unsigned, WPARAM, LPARAM)

    PURPOSE:  Processes messages

    MESSAGES:

        WM_CREATE     - create window
        WM_COMMAND    - application menu (About dialog box)
        WM_DESTROY    - destroy window
****************************************************************************/

long FTYPE MainWndProc
(
   HWND        hWnd,                          // window handle
   unsigned    message,                       // type of message
   WPARAM      wParam,                        // additional information
   LPARAM      lParam                         // additional information
)
{
   static  HANDLE  hInstance ;
   HMENU           hMenu;
   HDC             hdc;
   char            szBuffer[120];
   RECT            rect;
   DWORD           dwCurrentTime;
   DWORD           dwErrorTime;
   BOOL            bTimerOverrun;
   DWORD           dwExitCode;

   switch (message)
   {
      case WM_CREATE:
         //
         // initialize Menu
         //

         hMenu = GetMenu(hWnd);
         EnableMenuItem(hMenu, IDM_STOP, MF_BYCOMMAND | MF_GRAYED);

         hInstance = ((LPCREATESTRUCT) lParam)->hInstance;

         lpfnConfigDlgProc = MakeProcInstance (ConfigDlgProc, hInstance);
         lpfnScanDlgProc = MakeProcInstance (ScanDlgProc, hInstance);

         return 0 ;

      case WM_COMMAND:     /* message: from application menu */
         hMenu = GetMenu(hWnd);

         switch (LOWORD(wParam))
         {
            case IDM_SETTING:
               DialogBox (hInstance, MAKEINTRESOURCE(IDD_SETTING),
                         hWnd, lpfnConfigDlgProc);
               return 0;

            case IDM_SCAN :
               DialogBox (hInstance, MAKEINTRESOURCE(IDD_SCAN),
                        hWnd, lpfnScanDlgProc);
               return 0;

            case IDM_STOP :
               
			         if ( bThreadloop == TRUE )
                  {
				         bThreadloop = FALSE;
                     GetExitCodeThread( hThreadHandle, &dwExitCode);
                     if ( dwExitCode == STILL_ACTIVE )
                     {
                        TerminateThread( hThreadHandle, dwExitCode);
                     }
                  }

				      if (bRun == TRUE)
                  {
                     KillTimer(hWnd, 1);
                     bRun = FALSE;
                     // counter reset
                     if( (ErrCde = DRV_CounterReset(DriverHandle,
                       (LPARAM)gwChannel)) != 0)
                     {
                         DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                         MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
                     }
 	
                     DRV_DeviceClose((LONG far *)&DriverHandle);
                  }
                  
                  EnableMenuItem(hMenu, IDM_STOP, MF_BYCOMMAND | MF_GRAYED);
                  EnableMenuItem(hMenu, IDM_START, MF_BYCOMMAND | MF_ENABLED);

               return 0;
               //break;


            case IDM_START:

               //
               // Open Device
               //

               if (gnNumOfSubdevices == 0)
                   ErrCde = DRV_DeviceOpen(
                            DeviceList[gwDevice].dwDeviceNum,
                                (LONG far *)&DriverHandle);
               else
                  ErrCde = DRV_DeviceOpen(
                           SubDeviceList[gwSubDevice].dwDeviceNum,
                                (LONG far *)&DriverHandle);

               if (ErrCde != SUCCESS)
               {
                   strcpy(szErrMsg,"Device open error !");
                   MessageBox(hWnd,(LPCSTR)szErrMsg,"Device Open",MB_OK);
                   return 0;
               }

                    //
                    // get number of counter channels
                    //

                    ptDevFeatures.buffer = (LPDEVFEATURES)&DevFeatures;
                    ptDevFeatures.size = sizeof(DEVFEATURES);
                    if ((ErrCde = DRV_DeviceGetFeatures(DriverHandle,
                        (LPT_DeviceGetFeatures)&ptDevFeatures)) != SUCCESS)
                    {
                        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                        MessageBox(hWnd,(LPCSTR)szErrMsg,"Driver Message",MB_OK);
                        DRV_DeviceClose((LONG far *)&DriverHandle);
                        return 0;
                    }

                    // check number of counter channels
                    if (DevFeatures.usMaxTimerChl == 0)
                    {
                        MessageBox(hWnd,(LPCSTR)"No Counter Channel",
                            "Driver Message",MB_OK);
                        DRV_DeviceClose((LONG far *)&DriverHandle);
                        return 0;
                    }

                    //
                    // start counter                    
                    //			  
                    ptCounterConfig.usCounter     = gwChannel;
						  ptCounterConfig.usClkSrc      = gwClkSrc;
 						  ptCounterConfig.usInitValue   = (USHORT)g_usIniVal;
						  ptCounterConfig.usOutputMode  = gwOutputMode;
						  ptCounterConfig.usGateSrc     = gwGateSrc;

						  if((ErrCde = DRV_CounterConfig(DriverHandle,
                         (LPT_CounterConfig)&ptCounterConfig)) != 0)
                    {
                        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                        MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
                        return TRUE;
                    }

						  
                    ptCounterEventStart.counter = gwChannel;

                    if((ErrCde = DRV_CounterEventStart(DriverHandle,
                         (LPT_CounterEventStart)&ptCounterEventStart)) != 0)
                    {
                        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                        MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
                        return TRUE;
                    }
            
                    ptEnableEvent.EventType = ADS_EVT_TERMINATE_CNT0;                    
		              ptEnableEvent.Enabled   = gwIntFlag;
	                 ptEnableEvent.Count     = gwCount;
	                 if ( ErrCde = DRV_EnableEvent( DriverHandle, 
						     (LPT_EnableEvent)&ptEnableEvent ) != 0)
                    {
                       DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                       MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
                       return TRUE;
                    } 

			           if ( gwIntFlag )
                    {
                        hThreadHandle = CreateThread(0, 0,
                        (LPTHREAD_START_ROUTINE) UserThread,
                         0, 0, (LPDWORD)&dwThreadID);
			
			               bThreadloop = TRUE;
                    }
                    
                    //
                    // enable Stop Menu item and disable the others
                    //

                    EnableMenuItem(hMenu, IDM_STOP, MF_BYCOMMAND | MF_ENABLED);
                    EnableMenuItem(hMenu, IDM_START, MF_BYCOMMAND | MF_GRAYED);

                    //
                    // Set the new timer type and start it up.
                    //

                    if (SetTimer(hWnd, 1, gwScanTime, NULL) == (UINT)NULL)
                    {
                        MessageBox(hWnd, "Couldn't create timer.", "Notice!",
                            MB_OK);
                        DRV_DeviceClose((LONG far *)&DriverHandle);
                        return 0;
                    }

                    bRun = TRUE;

                    gdwStartTime = GetTickCount();
                    gwOverrunCount = 0;

                    return 0;
            }
            return 0;

        case WM_TIMER:

            //
            // Timer set to dispatch a WM_TIMER message has gone off.
            //

            //
            // check if timer is overrun
            //

            dwCurrentTime = GetTickCount();

            gdwElapseTime = gdwElapseTime + (DWORD)gwScanTime;
            dwErrorTime = dwCurrentTime - gdwElapseTime - gdwStartTime;
            if (dwErrorTime > (DWORD)40)        // maximum 40 ms scan time
            {
                gdwElapseTime = dwCurrentTime - gdwStartTime;
                gwOverrunCount ++;
                if (gwOverrunCount >= 10)
                {
                    bTimerOverrun = TRUE;
                    gwOverrunCount = 0;
                }
                else
                    bTimerOverrun = FALSE;
            }
            else
            {
                bTimerOverrun = FALSE;
                gwOverrunCount = 0;
            }


            //
            // read count
            //

            ptCounterEventRead.counter = gwChannel;
            ptCounterEventRead.overflow = (USHORT far *)&gwOverflow;
            ptCounterEventRead.count = (ULONG far *)&gdwReading;

            if ((ErrCde = DRV_CounterEventRead(DriverHandle,
                (LPT_CounterEventRead)&ptCounterEventRead)) != 0)
            {
                DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                KillTimer(hWnd, 1);
                MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
                DRV_DeviceClose((LONG far *)&DriverHandle);
                return TRUE;
            }

            //
            // Display Data
            //

            hdc = GetDC(hWnd);
            GetClientRect(hWnd, &rect);
            InvalidateRect(hWnd, NULL, TRUE);
            UpdateWindow(hWnd);
            wsprintf((LPSTR)szBuffer, "Counter Reading = %8lu", gdwReading);
            //sprintf((LPSTR)szBuffer, "Counter Reading = %8d", gdwReading);
            TextOut( hdc, 300, 200, szBuffer, 26 );

            sprintf( szBuffer, "Terminate Interrupt Count  = %4d\n", gwIntCount );
            TextOut( hdc, 300, 250, szBuffer, 33 );

            ReleaseDC(hWnd, hdc);

            return 0;

        case WM_DESTROY:
			{
			   if ( bThreadloop == TRUE )
			   {
				   bThreadloop = FALSE;
			   }
				if (bRun == TRUE)
			   {
                  KillTimer(hWnd, 1);

                  // counter reset
                  if( (ErrCde = DRV_CounterReset(DriverHandle,
                    (LPARAM)gwChannel)) != 0)
				  {
                      DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                      MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
				  }

                DRV_DeviceClose((LONG far *)&DriverHandle);
				}
                PostQuitMessage(0);
			}
            break;

        default:
            return (DefWindowProc(hWnd, message, wParam, lParam));
    }

    return ((LONG)NULL);
}

// ------------------------------------------------------------------
// UserThread
//
// -------------------------------------------------------------------
void UserThread()
{
   USHORT usEventType;
   LONG  ErrCde;

   gwIntCount = 0;

   while(bThreadloop)
   {
      // Check message
      ptCheckEvent.EventType = &usEventType;
      ptCheckEvent.Milliseconds = INFINITE;

      if ((ErrCde = DRV_CheckEvent(DriverHandle,
          (LPT_CheckEvent)&ptCheckEvent)) != 0)
      {
          MessageBox(hMainWnd, "Check Event Error !", "Thread Message", MB_OK);
		    bThreadloop = FALSE;
          return;
      }

      // Process interrupt event
      if ( usEventType == ADS_EVT_TERMINATE_CNT0 )
      {
         gwIntCount ++;  
		   //MessageBox( hMainWnd, "Counter Terminal Event Occured !","Interrupt Message",MB_OK);
      }
   }
}
