// ############################################################################
// ****************************************************************************
//              Copyright (C) 2000-2, Advantech Automation Corp.
//      THIS IS AN UNPUBLISHED WORK CONTAINING CONFIDENTIAL AND PROPRIETARY
//         INFORMATION WHICH IS THE PROHERTY OF ADVANTECH AUTOMATION CORP.
// 
//   ANY DISCLOSURE, USE, OR REPRODUCTION, WITHOUT WRITTEN AUTHORIZATION FROM
//             ADVANTECH AUTOMATION CORP., IS STRICTLY PROHIBITED
// ****************************************************************************
// ############################################################################
// 
// File:        COUNTER.c
// Created:     08/19/2002
// Description: Demo program for event counting
// ----------------------------------------------------------------------------

#include <windows.h>
#include <stdlib.h>
#include <dos.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include "..\..\..\..\include\driver.h"
#include "resource.h"

// ------------------------------------------------------------------------
// CONSTANT DEFINITION
// ------------------------------------------------------------------------
#define     MAX_DEVICES     100
#define     MAX_CNT_NUM      8
#define     ADS_EVT_NUM      9

// ------------------------------------------------------------------------
// GLOBAL VARIABLES
// ------------------------------------------------------------------------
HANDLE      hInst;                      // current instance
HWND        hMainWnd;                   // main window handle

static      DEVFEATURES          DevFeatures;    // structure for device features
static      PT_CounterEventStart ptCounterEventStart;
static      PT_CounterEventRead  ptCounterEventRead;
static      PT_DeviceGetFeatures ptDevFeatures;
static      PT_CounterConfig     ptCounterConfig;
static      PT_EnableEvent       ptEnableEvent;
static      PT_CheckEvent        ptCheckEvent;      // Check event 

char        szErrMsg[80];               // Use for MESSAGEBOX function
LRESULT     ErrCde;                     // Return error code

//
// used for fixed memory for the installed devices
//
DEVLIST     DeviceList[MAX_DEVICES];
DEVLIST     SubDeviceList[MAX_DEVICES];

LONG        DriverHandle = (LONG)NULL;          // driver handle
BOOL        bRun = FALSE;                       // flag for running
USHORT      gwDevice = 0, gwSubDevice = 0;      // device index
USHORT      gwChannel = 0;                      // input channel
USHORT      gwOverflow  = 0;                    // counter over 32 bit flag
ULONG       gdwReading  = 0;                    // read counter data
SHORT       gnNumOfDevices, gnNumOfSubdevices;  // number of installed devices
LONG        g_usIniVal =1;                      // number of the initial value of the counter
USHORT      gwScanTime = 1000;                  // scan time
DWORD       gdwStartTime;                       // start time
DWORD       gdwElapseTime = 0;                  // elapse time
USHORT      gwOverrunCount = 0;                 // overrun count
USHORT      gwStopFlag = 0;                     // stop button flag
FARPROC     lpfnConfigDlgProc;                  // config. dialog procedure
FARPROC     lpfnScanDlgProc;                    // scan dialog procedure
static  USHORT gwIntFlag  = 0;                  // interrupt enable(0)
static  USHORT gwCntEdge  = 0;		            // Count edge 0-rising, 1-falling
static  USHORT gwOutputEnable = 0x0004;         // count output enable (0-disable)
static  USHORT gwCntDirect    = 0x08;           // count direction up (0-down)
static  USHORT gwGatePolarity =0;               // 0-high level(rising edge)
                                                // 1-low level(falling edge)
static  USHORT gwOutputMode  = 0;               // defautl output mode 
static  USHORT gwCounterMode = 0;               // default per-define coutner mode 
static  USHORT gwGateSrc     = 0;               // default gate source
static  USHORT gwClkSrc      = 0;               // default count source

USHORT  gwGateSrcIndex       = 1;               // index of gate source
USHORT  gwCounterModeIndex   = 0;               // index of counter mode
USHORT  gwClkSrcIndex        = 1;               // index of count source
USHORT  gwOutputModeIndex    = 0;               // index of output mode

UINT        gwCount       = 1;                  // number of interrupt event count

HANDLE      hThreadHandle;
DWORD       dwThreadID = 0x00;
BOOL        bThreadflag = FALSE;
BOOL        bThreadloop = FALSE;
void UserThread();
// ------------------------------------------------------------------------
// FUNCTION DECLARATION
// ------------------------------------------------------------------------
BOOL InitApplication(HANDLE);
BOOL InitInstance(HANDLE, int);
long FTYPE MainWndProc(HWND, UINT, WPARAM, LPARAM);
int  FTYPE WinMain(HANDLE, HANDLE, LPSTR, int);


/***************************************************************************
    FUNCTION: WinMain(HANDLE, HANDLE, LPSTR, int)

    PURPOSE: calls initialization function, processes message loop
****************************************************************************/

int FTYPE WinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow)
HANDLE hInstance;                          /* current instance             */
HANDLE hPrevInstance;                      /* previous instance            */
LPSTR lpCmdLine;                           /* command line                 */
int nCmdShow;                              /* show-window type (open/icon) */
{
    MSG msg;                               /* message                      */

    if (!hPrevInstance)                /* Other instances of app running?  */
      if (!InitApplication(hInstance)) /* Initialize shared things         */
          return (FALSE);              /* Exits if unable to initialize    */

    // Perform initializations that apply to a specific instance
    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);

    // Acquire and dispatch messages until a WM_QUIT message is received.
    while (GetMessage(&msg,      /* message structure                      */
        (HWND)NULL,              /* handle of window receiving the message */
        (UINT)NULL,              /* lowest message to examine              */
        (UINT)NULL))             /* highest message to examine             */
    {
        TranslateMessage(&msg);  /* Translates virtual key codes           */
        DispatchMessage(&msg);   /* Dispatches message to window           */
    }
    return (msg.wParam);         /* Returns the value from PostQuitMessage */
}

/****************************************************************************
    FUNCTION: InitApplication(HANDLE)

    PURPOSE: Initializes window data and registers window class
****************************************************************************/

BOOL InitApplication(hInstance)
HANDLE hInstance;                            /* current instance           */
{
    WNDCLASS  wc;

    // Fill in window class structure with parameters that describe the
    // main window.
    wc.style = CS_HREDRAW | CS_VREDRAW; /* Class style(s).                 */
    wc.lpfnWndProc = (WNDPROC)MainWndProc;   /* window process procedure   */
    wc.cbClsExtra = 0;                  /* No per-class extra data.        */
    wc.cbWndExtra = 0;                  /* No per-window extra data.       */
    wc.hInstance = hInstance;           /* Application that owns the class.*/
    wc.hIcon = LoadIcon(hInstance, "IDI_ICON1");
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName =  "MyMenu";   /* Name of menu resource in .RC file.  */
    wc.lpszClassName = "MyClass";  /* Name used in call to CreateWindow. */

    // Register the window class and return success/failure code.
    return (RegisterClass(&wc));

}

/***************************************************************************
    FUNCTION:  InitInstance(HANDLE, int)

    PURPOSE:  Saves instance handle and creates main window
****************************************************************************/

BOOL InitInstance
(
    HANDLE          hInstance,          // Current instance identifier.
    int             nCmdShow            // Param for first ShowWindow() call.
)
{
    // Save the instance handle in static variable, which will be used in
    // many subsequence calls from this application to Windows.
    hInst = hInstance;

    // Create a main window for this application instance.
    hMainWnd = CreateWindow(
        "MyClass",                 /* See RegisterClass() call.           */
        "Advantech Driver Demo : Event Counter" , /* Window title bar  */
        WS_OVERLAPPEDWINDOW,        /* Window style.                       */
        CW_USEDEFAULT,              /* Default horizontal position.        */
        CW_USEDEFAULT,              /* Default vertical position.          */
        CW_USEDEFAULT,              /* Default width.                      */
        CW_USEDEFAULT,              /* Default height.                     */
        NULL,                       /* Overlapped windows have no parent.  */
        NULL,                       /* Use the window class menu.          */
        hInstance,                  /* This instance owns this window.     */
        NULL                        /* Pointer not needed.                 */
        );

    // If window could not be created, return "failure"
    if (!hMainWnd)
        return (FALSE);

    // Make the window visible; update its client area; and return "success"

    ShowWindow(hMainWnd, nCmdShow);   // Show the window
    UpdateWindow(hMainWnd);           // Sends WM_PAINT message
    return (TRUE);                // Returns the value from PostQuitMessage
}

/***************************************************************************
    FUNCTION: ConfigDlgProc(HWND, unsigned, WPARAM, LPARAM)

    PURPOSE:  Processes dialog box messages for configuration
****************************************************************************/

BOOL FTYPE ConfigDlgProc
(
    HWND        hDlg,                          // window handle
    unsigned    message,                       // type of message
    WPARAM      wParam,                        // additional information
    LPARAM      lParam                         // additional information
)
{
    int         i;
    DWORD       dwIndex;
    char        szBuffer[40];
    int         nOutEntries;

    switch (message)
    {
    case WM_INITDIALOG :

        // --------------------------------
        // Initialize Device List Combobox
        // --------------------------------

        // get number of the installed devices
        if ((ErrCde = DRV_DeviceGetNumOfList((SHORT far *)&gnNumOfDevices)) !=
            SUCCESS)
        {
             DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
             MessageBox(hMainWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
             return TRUE;
        }


        // ----------------------------------------------------------------
        // used for dynamic allocation memory for these installed devices
        //
        // if ((hDeviceList = GlobalAlloc(GHND, gnNumOfDevices *
        //      sizeof(DEVLIST))) == NULL)
        // {
        //    MessageBox(hMainWnd, (LPCSTR)"Not Enough Memory",
        //        "Memory Allocation", MB_OK);
        //    return TRUE;
        // }
        // DeviceList = (LPDEVLIST)GlobalLock(hDeviceList);
        // ----------------------------------------------------------------


        if (gnNumOfDevices > MAX_DEVICES)
            gnNumOfDevices = MAX_DEVICES;

        // retrieve the information of all installed devices

        if ((ErrCde = DRV_DeviceGetList((DEVLIST far *)&DeviceList[0],
            (SHORT)gnNumOfDevices, (SHORT far *)&nOutEntries)) != (LONG)SUCCESS)
        {
            DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
            MessageBox(hMainWnd,(LPCSTR)szErrMsg,"Driver Message",MB_OK);
            return TRUE;
        }

        // initialize the Device List Combobox with the retrieved information

        for (i = 0; i < gnNumOfDevices; i ++)
            SendDlgItemMessage(hDlg, IDC_DEVICE, CB_ADDSTRING, 0,
                        (LPARAM)((LPSTR)DeviceList[i].szDeviceName));

        SendDlgItemMessage(hDlg, IDC_DEVICE, CB_SETCURSEL,(WPARAM)gwDevice,
                        (LPARAM)0);


        // -----------------------------------------------------------
        // Initialize Module List Combobox for COM port or CAN devices
        // -----------------------------------------------------------

        // check if there is any device attached on this COM port or CAN

        gnNumOfSubdevices = DeviceList[gwDevice].nNumOfSubdevices;
        if (gnNumOfSubdevices > MAX_DEVICES)
            gnNumOfSubdevices = MAX_DEVICES;


        // --------------------------------------------------------------
        // used for dynamic allocation memory for these installed devices
        //
        // if ((hSubDeviceList = GlobalAlloc(GHND, gnNumOfSubdevices *
        //    sizeof(DEVLIST))) == NULL)
        // {
        //    MessageBox(hMainWnd, (LPCSTR)"Not Enough Memory",
        //        "Memory Allocation", MB_OK);
        //    return TRUE;
        // }
        //
        // SubDeviceList = (LPDEVLIST)GlobalLock(hSubDeviceList);
        // --------------------------------------------------------------


        // retrieve the information of all installed devices
        if (gnNumOfSubdevices != 0)
        {
            if ((ErrCde = DRV_DeviceGetSubList(
                (DWORD)DeviceList[gwDevice].dwDeviceNum,
                (DEVLIST far *)&SubDeviceList[0],
                (SHORT)gnNumOfSubdevices,
                (SHORT far *)&nOutEntries)) != (LONG)SUCCESS)
            {
                DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                MessageBox(hMainWnd,(LPCSTR)szErrMsg,"Driver Message",MB_OK);
                return TRUE;
            }


            // initialize the Module List Combobox with the retrieved
            // information

            EnableWindow(GetDlgItem(hDlg, IDC_MODULE), TRUE);
            SendDlgItemMessage(hDlg, IDC_MODULE, CB_RESETCONTENT, 0,
                    (LPARAM)((LPSTR)0));

            for (i = 0; i < gnNumOfSubdevices; i++)
                SendDlgItemMessage(hDlg, IDC_MODULE, CB_ADDSTRING, 0,
                        (LPARAM)((LPSTR)SubDeviceList[i].szDeviceName));

            SendDlgItemMessage(hDlg, IDC_MODULE, CB_SETCURSEL,
					(WPARAM)gwSubDevice, (LPARAM)0);
        }
        else
        {
            EnableWindow(GetDlgItem(hDlg, IDC_MODULE), FALSE);
            SendDlgItemMessage(hDlg, IDC_MODULE, CB_RESETCONTENT, 0,
                    (LPARAM)((LPSTR)0));
        }

		  // initial counter channel
        for ( i = 0; i< MAX_CNT_NUM; i++ )
		  {
           _itoa( i, szBuffer, 10 );
           SendDlgItemMessage( 
		     hDlg, 
		     IDC_ECHANNEL,
		     CB_ADDSTRING, 
		     0, 
		     ( LPARAM )( ( LPSTR )szBuffer ) );
		  }
        SendDlgItemMessage(hDlg,IDC_ECHANNEL,CB_SETCURSEL,gwChannel,(LPARAM)0); 
        
		  // initial counter value		 
        itoa(g_usIniVal, szBuffer, 10);
        SendDlgItemMessage(hDlg, IDC_CntIniVal, EM_REPLACESEL, 0,
            (LPARAM)((LPSTR)szBuffer));

		  // initial count output 		          
 		  if ( gwOutputEnable )
		  {
           CheckRadioButton( hDlg,IDC_OutputEnable,IDC_OutputDisable,IDC_OutputEnable );
		  }
        else
		  {
           CheckRadioButton( hDlg,IDC_OutputEnable,IDC_OutputDisable,IDC_OutputDisable );
           EnableWindow( GetDlgItem( hDlg,IDC_OUTMODE ), FALSE );
		  }
		  // initial output mode
        SendDlgItemMessage(
	        hDlg,
			  IDC_OUTMODE,
	        CB_ADDSTRING,
		     0,		     
			  (LPARAM)((LPSTR)"ACTIVE HIGH PULSE"));

        SendDlgItemMessage(
	        hDlg,
	        IDC_OUTMODE,
		     CB_ADDSTRING,
		     0,		     
			  (LPARAM)((LPSTR)"ACTIVE LOW PULSE"));

        SendDlgItemMessage(
		     hDlg,
		     IDC_OUTMODE,
		     CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"TC TPGGLED FROM LOW"));

        SendDlgItemMessage(
		     hDlg,
		     IDC_OUTMODE,
		     CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"TC TOGGLED FROM HIGH"));
		  
		  SendDlgItemMessage(
		     hDlg,
		     IDC_OUTMODE,
		     CB_SETCURSEL,
		     gwOutputModeIndex,
		     0);

		  // initial count source
		  SendDlgItemMessage(
	        hDlg,
			  IDC_CntClkSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"OUT N-1"));
		  
		  SendDlgItemMessage(
	        hDlg,
			  IDC_CntClkSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"CLK N"));
		  SendDlgItemMessage(
	        hDlg,
			  IDC_CntClkSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"CLK N-1"));
		  SendDlgItemMessage(
	        hDlg,
			  IDC_CntClkSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"FOUT0"));
		  SendDlgItemMessage(
	        hDlg,
			  IDC_CntClkSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"FOUT1"));
		  SendDlgItemMessage(
	        hDlg,
			  IDC_CntClkSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"FOUT2"));
		  SendDlgItemMessage(
	        hDlg,
			  IDC_CntClkSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"FOUT3"));

		  SendDlgItemMessage(
	        hDlg,
			  IDC_CntClkSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"GATE N-1"));
		  
		  SendDlgItemMessage(
	        hDlg,
			  IDC_CntClkSrc,
	        CB_SETCURSEL,
		     gwClkSrcIndex,
		     0);
		
		  // initial count edge
		  CheckRadioButton(hDlg, IDC_CntEdgeRising, IDC_CntEdgeFalling,
           (gwCntEdge)?IDC_CntEdgeFalling:IDC_CntEdgeRising );
		  
		  // initial count direction
        CheckRadioButton(hDlg, IDC_CntUp, IDC_CntDown,
           (gwCntDirect)?IDC_CntUp:IDC_CntDown );
		  
		  // initial count interrupt
        CheckRadioButton(hDlg, IDC_IntEnable, IDC_IntDisable,
           (gwIntFlag)?IDC_IntEnable:IDC_IntDisable );

		  SendDlgItemMessage(
	        hDlg,
			  IDC_GateSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"OUT N-1"));
		  SendDlgItemMessage(
	        hDlg,
			  IDC_GateSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"GATE N"));
		  SendDlgItemMessage(
	        hDlg,
			  IDC_GateSrc,
	        CB_ADDSTRING,
		     0,
		     (LPARAM)((LPSTR)"GATE N-1"));
		  
		  SendDlgItemMessage(
	        hDlg,
			  IDC_GateSrc,
	        CB_SETCURSEL,
		     gwGateSrcIndex,
		     0);

		  // initial gate polarity
		  CheckRadioButton(hDlg, IDC_GateHigh, IDC_GateLow,
           (gwGatePolarity)?IDC_GateLow:IDC_GateHigh );
        // initial count mode
	   SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"A"));
      SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"B"));
      SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"C"));
      SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"D"));
      SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"E"));
      SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"F"));
      SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"G"));
      SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"H"));
      SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"I"));
      SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"J"));
      SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"K"));
      SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"L"));
	   SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"O"));
	   SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"R"));
	   SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"U"));
	   SendDlgItemMessage(hDlg,IDC_CntMode,CB_ADDSTRING,0,(LPARAM)((LPSTR)"X"));
	   SendDlgItemMessage(hDlg,IDC_CntMode,CB_SETCURSEL,gwCounterModeIndex,0 );
	   if ( ( gwCounterModeIndex < 10 ) && ( gwCounterModeIndex % 3 == 0 ))
	   {
		   EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), FALSE );
	       EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), FALSE );
	       EnableWindow( GetDlgItem( hDlg, IDC_GateLow), FALSE );
	   }
      return TRUE;

    case WM_COMMAND :
         switch (LOWORD(wParam))
         {  
			case IDC_ECHANNEL:
				{
					gwChannel =(USHORT)SendDlgItemMessage(
							                   hDlg, 
													 IDC_ECHANNEL, 
													 CB_GETCURSEL, 
													 0, 
													 (LPARAM)0 );            
				}
            break;

         case IDC_CntMode:
				{
						gwCounterModeIndex = (USHORT)SendDlgItemMessage(
					            hDlg, 
							      IDC_CntMode, 
							      CB_GETCURSEL,
							      0,
							      (LPARAM)0 );
			   
			   switch( gwCounterModeIndex )
			   {
			   case 0:
					{
						gwCounterMode = MODE_A;
                  gwGateSrc     = PA_MODE_GATE_SRC_GATE_NO;						  
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), FALSE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), FALSE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), FALSE );
					}
					break;
				
			   case 1:
					{
						gwCounterMode = MODE_B;
					    EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), TRUE );
						 EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), TRUE );
						 EnableWindow( GetDlgItem( hDlg, IDC_GateLow), TRUE );
					}
					break;
				
			   case 2:
					{
						gwCounterMode = MODE_C;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), TRUE );
					}
					break;
					
				case 3:
					{
						gwCounterMode = MODE_D;
						gwGateSrc     = PA_MODE_GATE_SRC_GATE_NO;
                  EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), FALSE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), FALSE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), FALSE );
					}
					break;
					
				case 4:
					{
						gwCounterMode = MODE_E;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), TRUE );
					}
					break;
					
				case 5:
					{
						gwCounterMode = MODE_F;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), TRUE );
					}
					break;
					
				case 6:
					{
						gwCounterMode = MODE_G;
						gwGateSrc     = PA_MODE_GATE_SRC_GATE_NO;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), FALSE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), FALSE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), FALSE );
					}
					break;
					
				case 7:
					{
						gwCounterMode = MODE_H;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), TRUE );
					}
					break;
					
				case 8:
					{
						gwCounterMode = MODE_I;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), TRUE );
					}
					break;
           
				case 9:
					{
						gwCounterMode = MODE_J;
						gwGateSrc     = PA_MODE_GATE_SRC_GATE_NO;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), FALSE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), FALSE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), FALSE );
					}
					break;
					
				case 10:
					{
						gwCounterMode = MODE_K;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), TRUE );
					}
					break;
				case 11:
					{
						gwCounterMode = MODE_L;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), TRUE );
					}
					break;
				case 12:
					{
						gwCounterMode = MODE_O;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), TRUE );
					}
					break;
				case 13:
					{
						gwCounterMode = MODE_R;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), TRUE );
					}
					break;
				case 14:
					{
						gwCounterMode = MODE_U;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), TRUE );
					}
					break;
				case 15:
					{
						gwCounterMode = MODE_X;
						EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateHigh), TRUE );
						EnableWindow( GetDlgItem( hDlg, IDC_GateLow), TRUE );
					}
					break;
				}
				

			}
         break;
					
			case IDOK :
            {
              //
              // get device selection
              //
              if ((dwIndex = SendDlgItemMessage(hDlg, IDC_DEVICE,
                           CB_GETCURSEL, 0, 0)) != CB_ERR)
                   gwDevice = (WORD)dwIndex;

              //
              // get sub-device selection
              //
              if ((dwIndex = SendDlgItemMessage(hDlg, IDC_MODULE,
                           CB_GETCURSEL, 0, 0)) != CB_ERR)
                   gwSubDevice = (WORD)dwIndex;

             // get output mode
			   gwOutputModeIndex = (USHORT)SendDlgItemMessage(
					           hDlg, 
							     IDC_OUTMODE, 
							     CB_GETCURSEL,
							     0,
							     (LPARAM)0 );
				
				switch ( gwOutputModeIndex )
				{
				case 0:
					{
						gwOutputMode = PA_MODE_ACT_HIGH_TC_PULSE;
					}
					break;
				case 1:
					{
						gwOutputMode =	PA_MODE_ACT_LOW_TC_PULSE;
					}
					break;
				case 2:
					{
						gwOutputMode = PA_MODE_TC_TOGGLE_FROM_LOW;	
					}
					break;
				case 3:
					{
						gwOutputMode = PA_MODE_TC_TOGGLE_FROM_HIGH;
					}
					break; 
				}

				if (EnableWindow( GetDlgItem( hDlg,IDC_GateSrc ), FALSE ))
				{
					gwGateSrc = PA_MODE_GATE_SRC_GATE_NO;
				}
				else // get  gate source				
				{
					gwGateSrcIndex = (USHORT)SendDlgItemMessage(
					                         hDlg, 
							                   IDC_GateSrc, 
							                   CB_GETCURSEL,
							                   0,
							                   (LPARAM)0 );

				   switch ( gwGateSrcIndex )
					{

					case 0:
						{
							gwGateSrc = PA_MODE_GATE_SRC_OUT_N_M1;
						}
						break;
					case 1:
						{
							gwGateSrc = PA_MODE_GATE_SRC_GATE_N;
						}
						break;
					case 2:
						{
							gwGateSrc = PA_MODE_GATE_SRC_GATE_N_M1;
						}
						break;
					}
				}
					// get count source
					gwClkSrcIndex = (USHORT)SendDlgItemMessage(
					                   hDlg, 
							             IDC_CntClkSrc, 
							             CB_GETCURSEL,
							             0,
							             (LPARAM)0 );
               switch ( gwClkSrcIndex ) 
					{
					case 0:
						{
							gwClkSrc = PA_MODE_COUNT_SRC_OUT_N_M1;
						}
						break;
					case 1:
						{
							gwClkSrc = PA_MODE_COUNT_SRC_CLK_N;
						}
						break;
					case 2:
						{
							gwClkSrc = PA_MODE_COUNT_SRC_CLK_N_M1;
						}
						break;
					case 3:
						{
							gwClkSrc = PA_MODE_COUNT_SRC_FOUT_0;
						}
						break;
					case 4:
						{
							gwClkSrc = PA_MODE_COUNT_SRC_FOUT_1;
						}
						break;
					case 5:
						{
							gwClkSrc = PA_MODE_COUNT_SRC_FOUT_2;
						}
						break;
					case 6:
						{
							gwClkSrc = PA_MODE_COUNT_SRC_FOUT_3;
						}
						break;
					
					case 7:
						{
							gwClkSrc = PA_MODE_COUNT_SRC_GATE_N_M1;
						}
						break;
					}
				}

				case IDCANCEL :
                 EndDialog(hDlg, 0);
                 return TRUE;


				case IDC_OutputEnable:
               EnableWindow(GetDlgItem(hDlg, IDC_OUTMODE), TRUE);
					gwOutputEnable = PA_MODE_ENABLE_OUTPUT;
               break;
					
				case IDC_OutputDisable:
               EnableWindow(GetDlgItem(hDlg, IDC_OUTMODE), FALSE);
					gwOutputEnable = PA_MODE_DISABLE_OUTPUT;
               break;

				case IDC_CntEdgeRising:
					gwCntEdge = PA_MODE_COUNT_RISE_EDGE;
					break;

            case IDC_CntEdgeFalling:
					gwCntEdge = PA_MODE_COUNT_FALL_EDGE;
					break;

            case IDC_CntDown :
					gwCntDirect = PA_MODE_COUNT_DOWN;
					break;

			case  IDC_CntUp:
					gwCntDirect = PA_MODE_COUNT_UP;
					break;

            case IDC_GateHigh:
					gwGatePolarity = PA_MODE_GATE_POSITIVE;
					break;

			case IDC_GateLow:
					gwGatePolarity = PA_MODE_GATE_NEGATIVE;
					break;

         case  IDC_IntEnable:
					gwIntFlag = 1;
					break;
					
			case  IDC_IntDisable:
					gwIntFlag = 0;

			case IDC_CntIniVal :
                 if (HIWORD(wParam) == EN_KILLFOCUS)
					{
                   if(SendDlgItemMessage(hDlg, IDC_CntIniVal,
                      EM_GETMODIFY, 0, 0))
						 {
                       SendDlgItemMessage(hDlg, IDC_CntIniVal,
                          WM_GETTEXT, 10, (LPARAM)(LPSTR)szBuffer) ;                       
					        g_usIniVal = atol(szBuffer);
                       SendDlgItemMessage(hDlg, IDC_CntIniVal,
                          EM_SETMODIFY, FALSE, 0) ;
						 }
				   if ( ( g_usIniVal <= 0 )||( g_usIniVal > 65535 ))
				   {
					   MessageBox( hDlg, "Invalid Counter Initial Value", 
						   "Notice", MB_OK );
					   return TRUE;
				   }
			   }
               return TRUE;
					
            case IDC_DEVICE :

                //
                // When device selection is changed, it needs to
                // re-initialize sub-device combobox and input range
                // combobox.
                //

                if (HIWORD(wParam) == CBN_SELCHANGE)
                {
                    if ((dwIndex = SendDlgItemMessage(hDlg, IDC_DEVICE,
                        CB_GETCURSEL, 0, 0)) != CB_ERR)
                         gwDevice = (WORD)dwIndex;
                    else
                        return TRUE;


                    // ------------------------------------------------------
                    // Initialize Module Combobox for COM port or CAN devices
                    // ------------------------------------------------------

                    // check any device attached on this COM port or CAN

                    gnNumOfSubdevices = DeviceList[gwDevice].nNumOfSubdevices;
                    if (gnNumOfSubdevices > MAX_DEVICES)
                        gnNumOfSubdevices = MAX_DEVICES;


                    // retrieve the information of all installed devices

                    if (gnNumOfSubdevices != 0)
                    {
                        if ((ErrCde = DRV_DeviceGetSubList(
                            (DWORD)DeviceList[gwDevice].dwDeviceNum,
                            (DEVLIST far *)&SubDeviceList[0],
                            (SHORT)gnNumOfSubdevices,
                            (SHORT far *)&nOutEntries)) != (LONG)SUCCESS)
                        {
                            DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                            MessageBox(hMainWnd, (LPCSTR)szErrMsg,
                                "Driver Message", MB_OK);
                            return TRUE;
                        }


                        // initialize the Module List Combobox with the
                        // retrieved information

                        EnableWindow(GetDlgItem(hDlg, IDC_MODULE), TRUE);
                        SendDlgItemMessage(hDlg, IDC_MODULE, CB_RESETCONTENT,
                            0, (LPARAM)((LPSTR)0));

                        for (i = 0; i < gnNumOfSubdevices; i++)
                            SendDlgItemMessage(hDlg, IDC_MODULE, CB_ADDSTRING, 0,
                                (LPARAM)((LPSTR)SubDeviceList[i].szDeviceName));

                        gwSubDevice = 0;

                        SendDlgItemMessage(hDlg, IDC_MODULE, CB_SETCURSEL,
							(WPARAM)gwSubDevice, (LPARAM)0);
                    }
                    else
                    {
                        EnableWindow(GetDlgItem(hDlg, IDC_MODULE), FALSE);
                        SendDlgItemMessage(hDlg, IDC_MODULE, CB_RESETCONTENT,
                            0, (LPARAM)((LPSTR)0));
                    }
                }

                return TRUE;
         }

         break;
    }

    return FALSE ;
}


/***************************************************************************
    FUNCTION: ScanDlgProc(HWND, unsigned, WPARAM, LPARAM)

    PURPOSE:  Processes dialog box messages for scan time settings
****************************************************************************/

BOOL FTYPE ScanDlgProc
(
    HWND        hDlg,                          // window handle
    unsigned    message,                       // type of message
    WPARAM      wParam,                        // additional information
    LPARAM      lParam                         // additional information
)
{
    char        szBuffer[40];

    switch (message)
    {
    case WM_INITDIALOG :

        // ---------------------------------------------------
        // Initialize Scan Time Edit, Maximum accuracy: 40 ms
        // ---------------------------------------------------

        itoa(gwScanTime, szBuffer, 10);
        SendDlgItemMessage(hDlg, IDC_SCAN, EM_REPLACESEL, 0,
                        (LPARAM)((LPSTR)szBuffer));

        return TRUE;

    case WM_COMMAND :

         switch (LOWORD(wParam))
         {
            case IDOK :

                //
                // get scan time
                //

                if (SendDlgItemMessage(hDlg, IDC_SCAN,
                           EM_GETMODIFY, 0, 0))
                {
                    SendDlgItemMessage(hDlg, IDC_SCAN,
                            WM_GETTEXT, 10, (LPARAM)(LPSTR)szBuffer) ;
                    gwScanTime = atoi(szBuffer);
                    SendDlgItemMessage(hDlg, IDC_SCAN,
                              EM_SETMODIFY, FALSE, 0) ;
                }

            case IDCANCEL :
                EndDialog(hDlg, 0);
                return TRUE;

         }
         break;
    }
    return FALSE ;
}


/***************************************************************************
    FUNCTION: MainWndProc(HWND, unsigned, WPARAM, LPARAM)

    PURPOSE:  Processes messages

    MESSAGES:

        WM_CREATE     - create window
        WM_COMMAND    - application menu (About dialog box)
        WM_DESTROY    - destroy window
****************************************************************************/

long FTYPE MainWndProc
(
    HWND        hWnd,                          // window handle
    unsigned    message,                       // type of message
    WPARAM      wParam,                        // additional information
    LPARAM      lParam                         // additional information
)
{
    static  HANDLE  hInstance ;
    HMENU           hMenu;
    HDC             hdc;
    char            szBuffer[120];
    RECT            rect;
    DWORD           dwCurrentTime;
    DWORD           dwErrorTime;
    BOOL            bTimerOverrun;

    switch (message)
    {
        case WM_CREATE:

            //
            // initialize Stop Menu
            //

            hMenu = GetMenu(hWnd);
            EnableMenuItem(hMenu, IDM_STOP, MF_BYCOMMAND | MF_GRAYED);

            hInstance = ((LPCREATESTRUCT) lParam)->hInstance;

            lpfnConfigDlgProc = MakeProcInstance (ConfigDlgProc, hInstance);

            lpfnScanDlgProc = MakeProcInstance (ScanDlgProc, hInstance);

            return 0 ;

        case WM_COMMAND:     /* message: from application menu */

            hMenu = GetMenu(hWnd);

            switch (LOWORD(wParam))
            {
                case IDM_SETTING :
                    DialogBox (hInstance, MAKEINTRESOURCE(IDD_SETTING),
                         hWnd, lpfnConfigDlgProc) ;
                    return 0;

                case IDM_SCAN :
                    DialogBox (hInstance, MAKEINTRESOURCE(IDD_SCAN),
                         hWnd, lpfnScanDlgProc) ;
                    return 0;

                case IDM_STOP :

                    //
                    // kill timer and close driver
                    //

                    KillTimer(hWnd, 1);
                    
                    gwStopFlag = 1;
				        
                    // Close thread
			           bThreadloop = FALSE;

                    //
                    // counter reset
                    //

                    if ((ErrCde = DRV_CounterReset(DriverHandle,
                        (LPARAM)gwChannel)) != 0)
                    {
                        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                        MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
                    }

                    bRun = FALSE;
				  
 					if ( gwIntFlag )
					{
						ptEnableEvent.Enabled   = FALSE;
	               ptEnableEvent.Count     = gwCount;
	               if( ErrCde = DRV_EnableEvent( DriverHandle, 
						  (LPT_EnableEvent)&ptEnableEvent ) != 0)
						{ 
                           DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                           MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
                           return TRUE;
						} 
                  
					}
                     
					DRV_DeviceClose((LONG far *)&DriverHandle);
    
                    //
                    // reset menu item status
                    //

                    EnableMenuItem(hMenu, IDM_STOP, MF_BYCOMMAND | MF_GRAYED);
                    EnableMenuItem(hMenu, IDM_START, MF_BYCOMMAND | MF_ENABLED);

                    return 0;

                case IDM_START :

                    //
                    // Open Device
                    //

                    if (gnNumOfSubdevices == 0)
                        ErrCde = DRV_DeviceOpen(
                            DeviceList[gwDevice].dwDeviceNum,
                                (LONG far *)&DriverHandle);
                    else
                        ErrCde = DRV_DeviceOpen(
                            SubDeviceList[gwSubDevice].dwDeviceNum,
                                (LONG far *)&DriverHandle);

                    if (ErrCde != SUCCESS)
                    {
                        strcpy(szErrMsg,"Device open error !");
                        MessageBox(hWnd,(LPCSTR)szErrMsg,"Device Open",MB_OK);
                        return 0;
                    }


                    //
                    // get number of counter channels
                    //

                    ptDevFeatures.buffer = (LPDEVFEATURES)&DevFeatures;
                    ptDevFeatures.size = sizeof(DEVFEATURES);
                    if ((ErrCde = DRV_DeviceGetFeatures(DriverHandle,
                        (LPT_DeviceGetFeatures)&ptDevFeatures)) != SUCCESS)
                    {
                        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                        MessageBox(hWnd,(LPCSTR)szErrMsg,"Driver Message",MB_OK);
                        DRV_DeviceClose((LONG far *)&DriverHandle);
                        return 0;
                    }

                    // check number of counter channels
                    if (DevFeatures.usMaxTimerChl == 0)
                    {
                        MessageBox(hWnd,(LPCSTR)"No Counter Channel",
                            "Driver Message",MB_OK);
                        DRV_DeviceClose((LONG far *)&DriverHandle);
                        return 0;
                    }

                    //
                    // start counter                    
                    //			  
                    ptCounterConfig.usCounter     = gwChannel;
						  ptCounterConfig.usClkSrc      = gwClkSrc;
						  ptCounterConfig.usCountDirect = gwCntDirect;
						  ptCounterConfig.usCountEdge   = gwCntEdge;
						  ptCounterConfig.usCountMode   = gwCounterMode;
 						  ptCounterConfig.usInitValue   = (USHORT)g_usIniVal;
						  ptCounterConfig.usOutputEnable= gwOutputEnable;
						  ptCounterConfig.usOutputMode  = gwOutputMode;
						  ptCounterConfig.usGateSrc     = gwGateSrc;
                    ptCounterConfig.usGatePolarity= gwGatePolarity;

						  if((ErrCde = DRV_CounterConfig(DriverHandle,
                         (LPT_CounterConfig)&ptCounterConfig)) != 0)
                    {
                        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                        MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
                        return TRUE;
                    }

						  
                    ptCounterEventStart.counter = gwChannel;

                    if((ErrCde = DRV_CounterEventStart(DriverHandle,
                         (LPT_CounterEventStart)&ptCounterEventStart)) != 0)
                    {
                        DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                        MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
                        return TRUE;
                    }
            
				        switch ( gwChannel )
                    { 
					     case 0:
                       {
						         ptEnableEvent.EventType = ADS_EVT_TERMINATE_CNT0;
                       }
					        break;
					     case 1:
                       {
					            ptEnableEvent.EventType = ADS_EVT_TERMINATE_CNT1;
                       }
					        break;
					     case 2:
                       {
						         ptEnableEvent.EventType = ADS_EVT_TERMINATE_CNT2;
                       }
						     break;
					     case 3:
                       {
						         ptEnableEvent.EventType = ADS_EVT_TERMINATE_CNT3;
                       }
					        break;
					     case 4:
                       {
					            ptEnableEvent.EventType = ADS_EVT_TERMINATE_CNT4;
                       }
					        break;
					     case 5:
                       {
						         ptEnableEvent.EventType = ADS_EVT_TERMINATE_CNT5;
                       }
					        break;
					     case 6:
                       {
						         ptEnableEvent.EventType = ADS_EVT_TERMINATE_CNT6;
                       }
					        break;
					     case 7:
                       {
						         ptEnableEvent.EventType = ADS_EVT_TERMINATE_CNT7;
                       }
					        break;
			           default :
                      break;
                    }
					
		              ptEnableEvent.Enabled   = gwIntFlag;
	                 ptEnableEvent.Count     = gwCount;
	                 if ( ErrCde = DRV_EnableEvent( DriverHandle, 
						     (LPT_EnableEvent)&ptEnableEvent ) != 0)
						  {
                       DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                       MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
                       return TRUE;
						  } 
						  
			           if ( gwIntFlag )
                    {
                        hThreadHandle = CreateThread(0, 0,
                        (LPTHREAD_START_ROUTINE) UserThread,
                         0, 0, (LPDWORD)&dwThreadID);
			
			               bThreadloop = TRUE;
                    }
                    
                    //
                    // enable Stop Menu item and disable the others
                    //

                    EnableMenuItem(hMenu, IDM_STOP, MF_BYCOMMAND | MF_ENABLED);
                    EnableMenuItem(hMenu, IDM_START, MF_BYCOMMAND | MF_GRAYED);

                    //
                    // Set the new timer type and start it up.
                    //

                    if (SetTimer(hWnd, 1, gwScanTime, NULL) == (UINT)NULL)
                    {
                        MessageBox(hWnd, "Couldn't create timer.", "Notice!",
                            MB_OK);
                        DRV_DeviceClose((LONG far *)&DriverHandle);
                        return 0;
                    }

                    bRun = TRUE;

                    gdwStartTime = GetTickCount();
                    gwOverrunCount = 0;

                    return 0;
            }
            return 0;

        case WM_TIMER:

            //
            // Timer set to dispatch a WM_TIMER message has gone off.
            //

            //
            // check if timer is overrun
            //

            dwCurrentTime = GetTickCount();

            gdwElapseTime = gdwElapseTime + (DWORD)gwScanTime;
            dwErrorTime = dwCurrentTime - gdwElapseTime - gdwStartTime;
            if (dwErrorTime > (DWORD)40)        // maximum 40 ms scan time
            {
                gdwElapseTime = dwCurrentTime - gdwStartTime;
                gwOverrunCount ++;
                if (gwOverrunCount >= 10)
                {
                    bTimerOverrun = TRUE;
                    gwOverrunCount = 0;
                }
                else
                    bTimerOverrun = FALSE;
            }
            else
            {
                bTimerOverrun = FALSE;
                gwOverrunCount = 0;
            }


            //
            // read count
            //

            ptCounterEventRead.counter = gwChannel;
            ptCounterEventRead.overflow = (USHORT far *)&gwOverflow;
            ptCounterEventRead.count = (ULONG far *)&gdwReading;

            if ((ErrCde = DRV_CounterEventRead(DriverHandle,
                (LPT_CounterEventRead)&ptCounterEventRead)) != 0)
            {
                DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                KillTimer(hWnd, 1);
                MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
                DRV_DeviceClose((LONG far *)&DriverHandle);
                return TRUE;
            }

            //
            // Display Data
            //

            hdc = GetDC(hWnd);
            GetClientRect(hWnd, &rect);
            InvalidateRect(hWnd, NULL, TRUE);
            UpdateWindow(hWnd);
            wsprintf((LPSTR)szBuffer, "Counter Reading = %8lu", gdwReading);
            DrawText(hdc, szBuffer, -1, &rect,
                   DT_SINGLELINE | DT_CENTER | DT_VCENTER);
            ReleaseDC(hWnd, hdc);

            return 0;

        case WM_DESTROY:
			{
			   if ( bThreadloop == TRUE )
			   {
				   bThreadloop = FALSE;
			   }
				if (bRun == TRUE)
			   {
                  KillTimer(hWnd, 1);

                  // counter reset
                  if( (ErrCde = DRV_CounterReset(DriverHandle,
                    (LPARAM)gwChannel)) != 0)
				  {
                      DRV_GetErrorMessage(ErrCde,(LPSTR)szErrMsg);
                      MessageBox(hWnd,(LPCSTR)szErrMsg, "Driver Message", MB_OK);
				  }

                DRV_DeviceClose((LONG far *)&DriverHandle);
				}
                PostQuitMessage(0);
			}
            break;

        default:
            return (DefWindowProc(hWnd, message, wParam, lParam));
    }

    return ((LONG)NULL);
}

// ------------------------------------------------------------------
// UserThread
//
// -------------------------------------------------------------------
void UserThread()
{
    USHORT usEventType;
    LONG  ErrCde;

    while(bThreadloop)
    {
        // Check message
        ptCheckEvent.EventType = &usEventType;
        ptCheckEvent.Milliseconds = INFINITE;

		bThreadflag = TRUE;

        if ((ErrCde = DRV_CheckEvent(DriverHandle,
            (LPT_CheckEvent)&ptCheckEvent)) != 0)
        {
            MessageBox(hMainWnd, "Check Event Error !", "Thread Message", MB_OK);
		      bThreadloop = FALSE;
			   bThreadflag = FALSE;
            return ;
        }

        // Process interrupt event
        if ( (usEventType ==ADS_EVT_TERMINATE_CNT0 )&&(gwStopFlag == 1))
		{
			MessageBox( hMainWnd,"Counter 0 Stop!","Counter Message",MB_OK);
			gwStopFlag = 0;
		}
		else if ( usEventType == ADS_EVT_TERMINATE_CNT0 )
        {
			  MessageBox( hMainWnd, "Counter0 Terminal Event Occured !","Interrupt Message",MB_OK);
		}
        
		if ( (usEventType == ADS_EVT_TERMINATE_CNT1 )&&(gwStopFlag == 1))
		{
			MessageBox( hMainWnd,"Counter 1 Stop!","Counter Message",MB_OK);
			gwStopFlag = 0;
		}
        else if (usEventType == ADS_EVT_TERMINATE_CNT1 )
        {
			  MessageBox( hMainWnd, "Counter1 Terminal Event Occured !","Interrupt Message",MB_OK);
		}

		if ( (usEventType  == ADS_EVT_TERMINATE_CNT2 )&&(gwStopFlag == 1))
		{
			MessageBox( hMainWnd,"Counter 2 Stop!","Counter Message",MB_OK);
			gwStopFlag = 0;
		}
        else if (usEventType == ADS_EVT_TERMINATE_CNT2 )
        {
			  MessageBox( hMainWnd, "Counter2 Terminal Event Occured !","Interrupt Message",MB_OK);
		}

	    if ( (usEventType  == ADS_EVT_TERMINATE_CNT3 )&&(gwStopFlag == 1))
		{
			MessageBox( hMainWnd,"Counter 3 Stop!","Counter Message",MB_OK);
			gwStopFlag = 0;
		}
		else if (usEventType == ADS_EVT_TERMINATE_CNT3 )
        {
			  MessageBox( hMainWnd, "Counter3 Terminal Event Occured !","Interrupt Message",MB_OK);
		}

	    if ( (usEventType == ADS_EVT_TERMINATE_CNT4 )&&(gwStopFlag == 1))
		{
			MessageBox( hMainWnd,"Counter 4 Stop!","Counter Message",MB_OK);
			gwStopFlag = 0;
		}
		else if (usEventType == ADS_EVT_TERMINATE_CNT4 )
        {
			  MessageBox( hMainWnd, "Counter4 Terminal Event Occured !","Interrupt Message",MB_OK);
		}

	    if ( (usEventType == ADS_EVT_TERMINATE_CNT5 )&&(gwStopFlag == 1))
		{
			MessageBox( hMainWnd,"Counter 5 Stop!","Counter Message",MB_OK);
			gwStopFlag = 0;
		}
		else if (usEventType == ADS_EVT_TERMINATE_CNT5 )
      {
			  MessageBox( hMainWnd, "Counter5 Terminal Event Occured !","Interrupt Message",MB_OK);
		}

	   if ( (usEventType == ADS_EVT_TERMINATE_CNT6 )&&(gwStopFlag == 1))
		{
			MessageBox( hMainWnd,"Counter 6 Stop!","Counter Message",MB_OK);
			gwStopFlag = 0;
		}
		else if (usEventType == ADS_EVT_TERMINATE_CNT6 )
      {
			  MessageBox( hMainWnd, "Counter6 Terminal Event Occured !","Interrupt Message",MB_OK);
		}

	   if ( (usEventType == ADS_EVT_TERMINATE_CNT7 )&&(gwStopFlag == 1))
		{
			MessageBox( hMainWnd,"Counter 7 Stop!","Counter Message",MB_OK);
			gwStopFlag = 0;
		}
		else if (usEventType == ADS_EVT_TERMINATE_CNT7 )
      {
			  MessageBox( hMainWnd, "Counter7 Terminal Event Occured !","Interrupt Message",MB_OK);
		}

		bThreadflag = FALSE;
    }
}
