#if !defined(AFX_PCL752A_H__49393B05_D891_11D1_A2F3_B167A8D01C68__INCLUDED_)
#define AFX_PCL752A_H__49393B05_D891_11D1_A2F3_B167A8D01C68__INCLUDED_

#define OK	0
#define NOTINIT 4
#define ERR 1
#define REDEF_ERR 5
#define FAIL 3
#define MODEMBUSY 2

typedef struct tagRASCONFIG
{
	UINT	uLinkWay;	// Link way number
	UINT	uPortNum;	// comm port number (1-4)
	UINT	uBoardID;	// current Board address;
	UINT	uBaud;		// baud rate code
	char	cTEL[16];	// TEL number
	BOOL	bRS485;		// If RS232 port, specify zero. If RS485, non-zero
} RASCONFIG;


#if !defined(_WIN31)
    #define FEXPORT __declspec (dllexport)
    #define FTYPE  CALLBACK
#else
    #define FEXPORT extern
    #define FTYPE  FAR PASCAL
#endif

FEXPORT LRESULT FTYPE OpenComm(RASCONFIG FAR * LPRASCONFIG);
FEXPORT LRESULT FTYPE CloseComm(UINT uBoardID);
FEXPORT LRESULT FTYPE RASReadReg(UINT uBoardID,
										UINT uRegNum, UINT FAR * LPuData);
FEXPORT LRESULT FTYPE RASWriteReg(UINT uBoardID,
											UINT uRegNum, UINT uData);
FEXPORT LRESULT FTYPE RASSYSConfigSet(UINT uBoardID,
							UINT uNewBoardID, UINT uBaud, UINT uBoardConfig);
FEXPORT LRESULT FTYPE RASSYSConfigRead(UINT uBoardID,
							UINT FAR * LPuBaud, UINT FAR * LPuBoardConfig);
FEXPORT LRESULT FTYPE RASSYSReset(UINT uBoardID);
FEXPORT LRESULT FTYPE RASSetTime(UINT uBoardID,
													char FAR * LPString);
FEXPORT LRESULT FTYPE RASReadTime(UINT uBoardID,
													char FAR * LPString);
FEXPORT LRESULT FTYPE RASSetTELnum(UINT uBoardID,
													char FAR * LPString);
FEXPORT LRESULT FTYPE RASReadTELnum(UINT uBoardID,
													char FAR * LPString);
FEXPORT LRESULT FTYPE RASSetSYSID(UINT uBoardID,
													char FAR * LPString);
FEXPORT LRESULT FTYPE RASReadSYSID(UINT uBoardID,
													char FAR * LPString);
FEXPORT LRESULT FTYPE RASReadHardwareVer(UINT uBoardID,
													char FAR * LPString);
FEXPORT LRESULT FTYPE RASReadFirmwareVer(UINT uBoardID,
													char FAR * LPString);
FEXPORT LRESULT FTYPE RASAlarmSoundOff(UINT uBoardID);
FEXPORT LRESULT FTYPE RASAnalogIn(UINT uBoardID,
										UINT uChanNum, float FAR * LPfData);
FEXPORT LRESULT FTYPE RASDigitalIn(UINT uBoardID,
													  UINT FAR * LPuData);
FEXPORT LRESULT FTYPE RASDigitalOut(UINT uBoardID,
													   UINT uData);
FEXPORT LRESULT FTYPE RASReadDigitalOut(UINT uBoardID,
													UINT FAR * LPuData);
FEXPORT LRESULT FTYPE RASAlarmSetLimits(UINT uBoardID,
									UINT uChanNum, float fData, BOOL bHiLo);
FEXPORT LRESULT FTYPE RASAlarmReadLimits(UINT uBoardID,
							UINT uChanNum, float FAR * LPfData, BOOL bHiLo);
FEXPORT LRESULT FTYPE RASAlarmEnable(UINT uBoardID,
												UINT uChanNum, UINT uData);
FEXPORT LRESULT FTYPE RASAlarmReadEnable(UINT uBoardID,
										UINT uChanNum, UINT FAR * LPuData);
FEXPORT LRESULT FTYPE RASReadAlarmStatus(UINT uBoardID,
													LONG FAR * LPdwData);
FEXPORT LRESULT FTYPE RASSetWDT(UINT uBoardID,
												   UINT uData);
FEXPORT LRESULT FTYPE RASTrigWDT(UINT uBoardID);

FEXPORT LRESULT FTYPE DeviceConfigPCL(ULONG DeviceNum,DWORD BoardID,HWND owner);

FEXPORT LRESULT FTYPE EnableInt(USHORT Enabled, USHORT Count);

FEXPORT LRESULT FTYPE CheckInt(USHORT *EventType, DWORD TimeOut);

//LRESULT	RASWriteString(char *in);
//LRESULT RASReadString(char *in);
LRESULT TransmitComm(char *ptstring);
LRESULT ReceiveComm(char *ptstring);
LRESULT WriteStack(char *ptstring);
LRESULT ReadStack(char *ptstring);
LRESULT WriteRegister();
LRESULT ReadRegister();
LRESULT SendString();


#endif