// 841MView.cpp : implementation of the CP841MView class
//

#include "stdafx.h"
#include <process.h>
#include "841M.h"

#include "841MDoc.h"
#include "841MView.h"
#include "regdlg.h"
#include "..\..\..\Include\Driver.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HANDLE	m_hPort1Event;
HANDLE	m_hPort2Event;
HANDLE	m_hPort3Event;
HANDLE	m_hPort4Event;
HANDLE	m_hPort5Event;
HANDLE	m_hPort6Event;
HANDLE	m_hPort7Event;
HANDLE	m_hPort8Event;
HANDLE	m_hPort9Event;
HANDLE	m_hPort10Event;

void Port1EventHandle(void *dummy);
void Port2EventHandle(void *dummy);
void Port3EventHandle(void *dummy);
void Port4EventHandle(void *dummy);
void Port5EventHandle(void *dummy);
void Port6EventHandle(void *dummy);
void Port7EventHandle(void *dummy);
void Port8EventHandle(void *dummy);
void Port9EventHandle(void *dummy);
void Port10EventHandle(void *dummy);
BOOL QueryConfigDeviceData(DWORD dwDeviceNum,char * szEntry, LPBYTE szDataBuf, DWORD dwDataSize);

/////////////////////////////////////////////////////////////////////////////
// CP841MView

IMPLEMENT_DYNCREATE(CP841MView, CFormView)

BEGIN_MESSAGE_MAP(CP841MView, CFormView)
	//{{AFX_MSG_MAP(CP841MView)
	ON_BN_CLICKED(IDC_CANCLOSEBTN,        OnCANClose)
	ON_BN_CLICKED(IDC_CANENABLEMESSAGING, OnCANEnableMessaging)
	ON_BN_CLICKED(IDC_CANHWRESETBTN,      OnCANHwReset)
	ON_BN_CLICKED(IDC_CANINITBTN,         OnCANInit)
	ON_BN_CLICKED(IDC_CANOPENBTN,         OnCANOpen)
	ON_BN_CLICKED(IDC_CANQUERYBTN,        OnCANQueryMsg)
	ON_BN_CLICKED(IDC_CANRESETBTN,        OnCANReset)
	ON_BN_CLICKED(IDC_CANSENDMSGBTN,      OnCANSendMsg)
	ON_BN_CLICKED(IDC_CANSETACPBTN,       OnCANSetAcp)
	ON_BN_CLICKED(IDC_CANSETBAUDBTN,      OnCANSetBaud)
	ON_BN_CLICKED(IDC_CANSETNORMALBTN,    OnCANSetNormal)
	ON_BN_CLICKED(IDC_CANSETOUTCTRLBTN,   OnCANSetOutCtrl)
	ON_BN_CLICKED(IDC_CANWAITFORMSGBTN,   OnCANWaitForMsg)
	ON_BN_CLICKED(IDC_REGISTERBTN,        OnRegisterView)
	ON_EN_CHANGE (IDC_PORTEDIT,           OnChangePortEdit)
	ON_EN_CHANGE (IDC_ACPCODEEDIT,        OnChangeAcpCodeEdit)
	ON_EN_CHANGE (IDC_ACPMASKEDIT,        OnChangeAcpMaskEdit)
	ON_EN_CHANGE (IDC_BTR0EDIT,           OnChangeBTR0Edit)
	ON_EN_CHANGE (IDC_BTR1EDIT,           OnChangeBTR1Edit)
	ON_BN_CLICKED(IDC_ENABLEWAITCHK,      OnEnableWaitChk)
	ON_BN_CLICKED(IDC_INTMASKCHK1,        OnIntMaskChk1)
	ON_BN_CLICKED(IDC_INTMASKCHK2,        OnIntMaskChk2)
	ON_BN_CLICKED(IDC_INTMASKCHK3,        OnIntMaskChk3)
	ON_BN_CLICKED(IDC_INTMASKCHK4,        OnIntMaskChk4)
	ON_EN_CHANGE (IDC_INTMASKEDIT,        OnChangeIntMaskEdit)
	ON_EN_CHANGE (IDC_OUTCTLEDIT,         OnChangeOutCtrlEdit)
	ON_EN_CHANGE (IDC_TIMEOUTEDIT,        OnChangeTimeOutEdit)
	ON_EN_CHANGE (IDC_TRANSFERBUFEDIT,    OnChangeTransferBufEdit)
	ON_EN_CHANGE (IDC_TXIDEDIT,           OnChangeTxIDEdit)
	ON_BN_CLICKED(IDC_HANDLINGEVENTBTN,   OnHandlingEvent)
	ON_MESSAGE   (WM_CANTRANSMITCOMPLETE, OnCANTransmitComplete)
	ON_MESSAGE   (WM_CANMESSAGE,          OnCANMessage)
	ON_MESSAGE   (WM_CANERROR,            OnCANError)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND   (ID_FILE_PRINT,          CFormView::OnFilePrint)
	ON_COMMAND   (ID_FILE_PRINT_DIRECT,   CFormView::OnFilePrint)
	ON_COMMAND   (ID_FILE_PRINT_PREVIEW,  CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CP841MView construction/destruction

CP841MView::CP841MView()
	: CFormView(CP841MView::IDD)
{
	//{{AFX_DATA_INIT(CP841MView)
	m_AcpCode         = 0;
	m_AcpMask         = 0xff;
	m_BTR0            = 3;
	m_BTR1            = 0x1c;
	m_EventLog        = _T("");
	m_EnReceiveInt    = FALSE;
	m_EnTransmitInt   = FALSE;
	m_EnErrorInt      = FALSE;
	m_EnOverrunInt    = FALSE;
	m_IntMask         = 0;
	m_OutCtrlCode     = 0;
	m_Port            = 0;
	m_RxBuf           = _T("");
	m_RxID            = 0;
	m_TimeOut         = 500;
	m_TxBuf           = _T("");
	m_TxID            = 0;
	m_WaitForComplete = FALSE;
	m_HostID          = _T("");
	m_DeviceName      = _T("");
	m_DeviceNum       = _T("");
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_bRepeat = FALSE;
	m_bThreadCreated[0] = m_bThreadCreated[1] = FALSE;
}

CP841MView::~CP841MView()
{
	m_bRepeat = FALSE;
}

BOOL CP841MView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CP841MView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CP841MView)
	DDX_Text( pDX, IDC_ACPCODEEDIT,     m_AcpCode);
	DDX_Text( pDX, IDC_ACPMASKEDIT,     m_AcpMask);
	DDX_Text( pDX, IDC_BTR0EDIT,        m_BTR0);
	DDX_Text( pDX, IDC_BTR1EDIT,        m_BTR1);
	DDX_Text( pDX, IDC_EVENTEDIT,       m_EventLog);
	DDX_Check(pDX, IDC_INTMASKCHK1,     m_EnReceiveInt);
	DDX_Check(pDX, IDC_INTMASKCHK2,     m_EnTransmitInt);
	DDX_Check(pDX, IDC_INTMASKCHK3,     m_EnErrorInt);
	DDX_Check(pDX, IDC_INTMASKCHK4,     m_EnOverrunInt);
	DDX_Text( pDX, IDC_INTMASKEDIT,     m_IntMask);
	DDX_Text( pDX, IDC_OUTCTLEDIT,      m_OutCtrlCode);
	DDX_Text( pDX, IDC_PORTEDIT,        m_Port);
	DDX_Text( pDX, IDC_RECEIVEDBUFEDIT, m_RxBuf);
	DDX_Text( pDX, IDC_RXIDEDIT,        m_RxID);
	DDX_Text( pDX, IDC_TIMEOUTEDIT,     m_TimeOut);
	DDX_Text( pDX, IDC_TRANSFERBUFEDIT, m_TxBuf);
	DDX_Text( pDX, IDC_TXIDEDIT,        m_TxID);
	DDX_Check(pDX, IDC_ENABLEWAITCHK,   m_WaitForComplete);
	DDX_Text( pDX, IDC_HOSTID,          m_HostID);
	DDX_Text( pDX, IDC_DEVICENAME,      m_DeviceName);
	DDX_Text( pDX, IDC_DEVICENUM,       m_DeviceNum);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CP841MView drawing

void CP841MView::OnDraw(CDC* pDC)
{
	CP841MDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CP841MView printing

BOOL CP841MView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CP841MView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CP841MView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CP841MView diagnostics

#ifdef _DEBUG
void CP841MView::AssertValid() const
{
	CFormView::AssertValid();
}

void CP841MView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CP841MDoc* CP841MView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CP841MDoc)));
	return (CP841MDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CP841MView message handlers
void CP841MView::OnInitialUpdate() 
{
	char	cTemp[10];
	char	gszDeviceName[60];

	CFormView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	m_uDevNum = GetDocument()->m_DeviceNum;
	itoa( (m_uDevNum % 1000), cTemp, 10 );
	m_DeviceNum = cTemp;
	if (QueryConfigDeviceData( (m_uDevNum % 1000),	"DeviceName", (LPBYTE)gszDeviceName, 60 ) == TRUE) {
		m_DeviceName = gszDeviceName;
	}

	UpdateData(FALSE);
}

void CP841MView::OnCANOpen() 
{
	// TODO: Add your control notification handler code here
	int		iHostID;
    int     iBaudRate;
	char	cTemp[10];

	if (CANPortOpen( m_uDevNum, (WORD *)&m_Port, (WORD *)&iHostID,
                    (WORD *)&iBaudRate) != SUCCESS) {
		MessageBox( "CAN port open error!", "CANOpen ( )", MB_ICONHAND|MB_ICONSTOP|MB_ICONERROR);
		return;
	}
	itoa( iHostID, cTemp, 10 );
	m_HostID = cTemp;

	UpdateData(FALSE);
}

void CP841MView::OnCANClose() 
{
	// TODO: Add your control notification handler code here
	CANPortClose( m_Port );
}

void CP841MView::OnCANHwReset() 
{
	// TODO: Add your control notification handler code here
	CANHwReset( m_Port );
}

void CP841MView::OnCANInit() 
{
	// TODO: Add your control notification handler code here
	CANInit( m_Port, m_BTR0, m_BTR1, (UCHAR)m_IntMask );
}

void CP841MView::OnCANReset() 
{
	// TODO: Add your control notification handler code here
	CANReset( m_Port );
}

void CP841MView::OnCANSetAcp() 
{
	// TODO: Add your control notification handler code here
	CANSetAcp( m_Port, m_AcpCode, m_AcpMask );
}

void CP841MView::OnCANSetBaud() 
{
	// TODO: Add your control notification handler code here
	CANSetBaud( m_Port, m_BTR0, m_BTR1);	
}

void CP841MView::OnCANSetNormal() 
{
	// TODO: Add your control notification handler code here
	CANSetNormal( m_Port );
}

void CP841MView::OnCANSetOutCtrl() 
{
	// TODO: Add your control notification handler code here
	CANSetOutCtrl( m_Port, m_OutCtrlCode );
}

void CP841MView::OnCANQueryMsg() 
{
	// TODO: Add your control notification handler code here
	LPSTR	cstr;
	int	bReady = FALSE;
	int nLength;
	UCHAR uChar;
    
	// query CAN message
	CANQueryMsg( m_Port, (int *)&bReady, (UCHAR*)cReBuf );		
	if ( bReady ) {
		// Get ID
		m_RxID   =  (WORD)cReBuf[0];
		m_RxID  &=  0x00ff;
		m_RxID <<= 3;
		m_RxID  |=  ((cReBuf[1] >> 5) & 0x07);
		// Get message
		cstr = m_RxBuf.GetBuffer(30);
		// get receive data length
		nLength = cReBuf[1] & 0x0f;	

    	for ( int i = 0; i<nLength; i++ )
		{
			uChar = (UCHAR) cReBuf[i+2];
			sprintf( cstr+3*i, "%02X ", uChar );
		}

		m_RxBuf.ReleaseBuffer();
		UpdateData(FALSE);		// Update display
	} else {
		MessageBox("Message is not ready!", "Query Error !",
					MB_OK | MB_ICONERROR );
	}
}

void CP841MView::OnCANWaitForMsg() 
{
	// TODO: Add your control notification handler code here
	LPSTR	cstr;
	bool	bReady = FALSE;

	if ( CANWaitForMsg( m_Port, (UCHAR*)cReBuf, m_TimeOut) ) {	// Wait for CAN message
		MessageBox("Wait for message is time out!", "Query Error !",
					MB_OK | MB_ICONERROR );
	} else {
		// Get ID
		m_RxID   = (WORD)cReBuf[0];
		m_RxID  &= 0x00ff;
		m_RxID <<= 3;
		m_RxID  |= ((cReBuf[1] >> 5) & 0x07);
		// Get message
		cstr = m_RxBuf.GetBuffer(20);
		strcpy( cstr, &cReBuf[2] );
		m_RxBuf.ReleaseBuffer();
		// Update display
		UpdateData(FALSE);		
	}
}

void CP841MView::OnCANSendMsg() 
{
	// TODO: Add your control notification handler code here
	UCHAR	ucIdent, ucRTRData;
	LPSTR	cstr;

	ucIdent = (UCHAR)((m_TxID & 0xfff8) >> 3);
	ucRTRData = 0;
	ucRTRData = (UCHAR)((m_TxID & 0x07) << 5);
	cstr = m_TxBuf.GetBuffer(20);
	if (strlen(cstr) > 8) {
		MessageBox("Transmit Data too long!(Max. length is 8 char.)", "Transmit Error !",
					MB_OK | MB_ICONERROR );
		m_TxBuf.ReleaseBuffer();
		return;
	}
	ucRTRData |= (strlen(cstr) & 0x0f);
	cTxBuf[0] = ucIdent;
	cTxBuf[1] = ucRTRData;
	strcpy( &cTxBuf[2], cstr );
	m_TxBuf.ReleaseBuffer();
	if ( m_WaitForComplete ) {
		if (CANSendMsg( m_Port, (UCHAR*)cTxBuf, TRUE)) {
			MessageBox("Transmit Data time out!", "Transmit Error !",
					MB_OK | MB_ICONERROR );
		}
	} else
		CANSendMsg( m_Port, (UCHAR*)cTxBuf, FALSE);
}

void CP841MView::OnCANEnableMessaging() 
{
	// TODO: Add your control notification handler code here

	if ( m_EnReceiveInt ) {
		CANEnableMessaging( m_Port, 1, TRUE, m_hWnd,(UCHAR*)cReBuf );
	}
	if ( m_EnTransmitInt ) {
		CANEnableMessaging( m_Port, 0, TRUE, m_hWnd, NULL );
	}
	if ( m_EnErrorInt ) {
		CANEnableMessaging( m_Port, 2, TRUE, m_hWnd, NULL );
	}
	if ( m_EnOverrunInt ) {
		CANEnableMessaging( m_Port, 3, TRUE, m_hWnd, NULL );
	}
}

void CP841MView::OnRegisterView() 
{
	// TODO: Add your control notification handler code here
	CRegisterView RegDlg;

	RegDlg.m_Port = m_Port;
	RegDlg.DoModal();
}

void CP841MView::OnChangePortEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnChangeAcpCodeEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnChangeAcpMaskEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnChangeBTR0Edit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnChangeBTR1Edit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnEnableWaitChk() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnIntMaskChk1() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnIntMaskChk2() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnIntMaskChk3() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnIntMaskChk4() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnChangeIntMaskEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnChangeOutCtrlEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnChangeTimeOutEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnChangeTransferBufEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnChangeTxIDEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CP841MView::OnHandlingEvent() 
{
	// TODO: Add your control notification handler code here
/*	char	EventName[50];

	CANGetEventName( m_Port, EventName );
	switch ( m_Port ) {
	case 1:		// Enable Port 1 message
		if ( !m_bThreadCreated[0] ) {
//			m_hPort1Event = OpenEvent (SYNCHRONIZE, FALSE, EventName);
			m_hPort1Event = OpenEvent (EVENT_ALL_ACCESS, FALSE, EventName);
			_beginthread( Port1EventHandle, 0, m_hWnd );
			m_bThreadCreated[0] = TRUE;
		}
		break;
	case 2:		// Enable Port 2 message
		if ( !m_bThreadCreated[1] ) {
			m_hPort2Event = OpenEvent (EVENT_ALL_ACCESS, FALSE, EventName) ;
			_beginthread( Port2EventHandle, 0, m_hWnd );
			m_bThreadCreated[1] = TRUE;
		}
		break;
	case 3:		// Enable Port 3 message
		if ( !m_bThreadCreated[2] ) {
			m_hPort3Event = OpenEvent (EVENT_ALL_ACCESS, FALSE, EventName) ;
			_beginthread( Port3EventHandle, 0, m_hWnd );
			m_bThreadCreated[2] = TRUE;
		}
		break;
	case 4:		// Enable Port 4 message
		if ( !m_bThreadCreated[3] ) {
			m_hPort4Event = OpenEvent (EVENT_ALL_ACCESS, FALSE, EventName) ;
			_beginthread( Port4EventHandle, 0, m_hWnd );
			m_bThreadCreated[3] = TRUE;
		}
		break;
	case 5:		// Enable Port 5 message
		if ( !m_bThreadCreated[4] ) {
			m_hPort5Event = OpenEvent (EVENT_ALL_ACCESS, FALSE, EventName) ;
			_beginthread( Port5EventHandle, 0, m_hWnd );
			m_bThreadCreated[4] = TRUE;
		}
		break;
	case 6:		// Enable Port 6 message
		if ( !m_bThreadCreated[5] ) {
			m_hPort6Event = OpenEvent (EVENT_ALL_ACCESS, FALSE, EventName) ;
			_beginthread( Port6EventHandle, 0, m_hWnd );
			m_bThreadCreated[5] = TRUE;
		}
		break;
	case 7:		// Enable Port 7 message
		if ( !m_bThreadCreated[6] ) {
			m_hPort7Event = OpenEvent (EVENT_ALL_ACCESS, FALSE, EventName) ;
			_beginthread( Port7EventHandle, 0, m_hWnd );
			m_bThreadCreated[6] = TRUE;
		}
		break;
	case 8:		// Enable Port 8 message
		if ( !m_bThreadCreated[7] ) {
			m_hPort8Event = OpenEvent (EVENT_ALL_ACCESS, FALSE, EventName) ;
			_beginthread( Port8EventHandle, 0, m_hWnd );
			m_bThreadCreated[7] = TRUE;
		}
		break;
	case 9:		// Enable Port 9 message
		if ( !m_bThreadCreated[8] ) {
			m_hPort9Event = OpenEvent (EVENT_ALL_ACCESS, FALSE, EventName) ;
			_beginthread( Port9EventHandle, 0, m_hWnd );
			m_bThreadCreated[8] = TRUE;
		}
		break;
	case 10:	// Enable Port 10 message
		if ( !m_bThreadCreated[9] ) {
			m_hPort10Event = OpenEvent (EVENT_ALL_ACCESS, FALSE, EventName) ;
			_beginthread( Port10EventHandle, 0, m_hWnd );
			m_bThreadCreated[9] = TRUE;
		}
		break;
	} */
    CANEnableEvent(m_Port, true);
	switch ( m_Port ) {
	case 1:		// Enable Port 1 message
		if ( !m_bThreadCreated[0] ) {
			_beginthread( Port1EventHandle, 0, m_hWnd );
			m_bThreadCreated[0] = TRUE;
		}
		break;
	case 2:		// Enable Port 2 message
		if ( !m_bThreadCreated[1] ) {
			_beginthread( Port2EventHandle, 0, m_hWnd );
			m_bThreadCreated[1] = TRUE;
		}
		break;
	case 3:		// Enable Port 3 message
		if ( !m_bThreadCreated[2] ) {
			_beginthread( Port3EventHandle, 0, m_hWnd );
			m_bThreadCreated[2] = TRUE;
		}
		break;
	case 4:		// Enable Port 4 message
		if ( !m_bThreadCreated[3] ) {
			_beginthread( Port4EventHandle, 0, m_hWnd );
			m_bThreadCreated[3] = TRUE;
		}
		break;
	case 5:		// Enable Port 5 message
		if ( !m_bThreadCreated[4] ) {
			_beginthread( Port5EventHandle, 0, m_hWnd );
			m_bThreadCreated[4] = TRUE;
		}
		break;
	case 6:		// Enable Port 6 message
		if ( !m_bThreadCreated[5] ) {
			_beginthread( Port6EventHandle, 0, m_hWnd );
			m_bThreadCreated[5] = TRUE;
		}
		break;
	case 7:		// Enable Port 7 message
		if ( !m_bThreadCreated[6] ) {
			_beginthread( Port7EventHandle, 0, m_hWnd );
			m_bThreadCreated[6] = TRUE;
		}
		break;
	case 8:		// Enable Port 8 message
		if ( !m_bThreadCreated[7] ) {
			_beginthread( Port8EventHandle, 0, m_hWnd );
			m_bThreadCreated[7] = TRUE;
		}
		break;
	case 9:		// Enable Port 9 message
		if ( !m_bThreadCreated[8] ) {
			_beginthread( Port9EventHandle, 0, m_hWnd );
			m_bThreadCreated[8] = TRUE;
		}
		break;
	case 10:	// Enable Port 10 message
		if ( !m_bThreadCreated[9] ) {
			_beginthread( Port10EventHandle, 0, m_hWnd );
			m_bThreadCreated[9] = TRUE;
		}
		break;
	}
	m_bRepeat = TRUE;
}

LRESULT CP841MView::OnCANTransmitComplete(WPARAM wParam, LPARAM lParam)
{
	char	cMsg[80];

	sprintf( cMsg, "Port %d message transmite complete!", wParam );
	m_EventLog = cMsg;
	UpdateData(FALSE);
	return 0;
}

LRESULT CP841MView::OnCANMessage(WPARAM wParam, LPARAM lParam)
{
	char	cMsg[80];
    LPSTR	pStr;

	int   nLength;
	UCHAR uChar;
    

	pStr = m_RxBuf.GetBuffer(30);

    // Get ID
	m_RxID   = (WORD)cReBuf[0];
	m_RxID  &= 0x00ff;
	m_RxID <<= 3;
	m_RxID  |= ((cReBuf[1] >> 5) & 0x07);

	// get receive data length
	nLength = cReBuf[1] & 0x0f;	
	// Get message
   	for ( int i = 0; i<nLength; i++ )
	{
		uChar = (UCHAR) cReBuf[i+2];
		sprintf( pStr + 3*i, "%02X ", uChar );
	}

	m_RxBuf.ReleaseBuffer();

	sprintf( cMsg, "Port %d receive message!", wParam );
	m_EventLog = cMsg;
	UpdateData(FALSE);        // Update display
	return 0;
}

LRESULT CP841MView::OnCANError(WPARAM wParam, LPARAM lParam)
{
	char	cMsg[80];

	sprintf( cMsg, "Port %d error!", wParam );
	m_EventLog = cMsg;
	UpdateData(FALSE);
	return 0;
}



void Port1EventHandle(void *dummy)
{
	HWND	ActhWnd;

	while (1) {
//		if (WaitForSingleObject (m_hPort1Event, INFINITE) == WAIT_OBJECT_0) {	// Event is singled
		if (!CANCheckEvent(1, 100)) {	// Event is singled
//			ResetEvent(m_hPort1Event);		// Clear event
			ActhWnd = GetActiveWindow();
			MessageBox(ActhWnd, "Port 1 Event!", "Event!", MB_OK | MB_ICONERROR );
		}
	}
}

void Port2EventHandle(void *dummy)
{
	HWND	ActhWnd;

	while (1) {
//		if (WaitForSingleObject (m_hPort2Event, 1000) == WAIT_OBJECT_0) {	// Event is singled
		if (!CANCheckEvent(2, 100)) {	// Event is singled
//			ResetEvent(m_hPort2Event);		// Clear event
			ActhWnd = GetActiveWindow();
			MessageBox(ActhWnd, "Port 2 Event!", "Event!", MB_OK | MB_ICONERROR );
		}
	}
}

void Port3EventHandle(void *dummy)
{
	HWND	ActhWnd;

	while (1) {
//		if (WaitForSingleObject (m_hPort3Event, 1000) == WAIT_OBJECT_0) {	// Event is singled
		if (!CANCheckEvent(3, 100)) {	// Event is singled
//			ResetEvent(m_hPort3Event);		// Clear event
			ActhWnd = GetActiveWindow();
			MessageBox(ActhWnd, "Port 3 Event!", "Event!", MB_OK | MB_ICONERROR );
		}
	}
}

void Port4EventHandle(void *dummy)
{
	HWND	ActhWnd;

	while (1) {
//		if (WaitForSingleObject (m_hPort4Event, 1000) == WAIT_OBJECT_0) {	// Event is singled
		if (!CANCheckEvent(4, 100)) {	// Event is singled
//			ResetEvent(m_hPort4Event);		// Clear event
			ActhWnd = GetActiveWindow();
			MessageBox(ActhWnd, "Port 4 Event!", "Event!", MB_OK | MB_ICONERROR );
		}
	}
}

void Port5EventHandle(void *dummy)
{
	HWND	ActhWnd;

	while (1) {
//		if (WaitForSingleObject (m_hPort5Event, 1000) == WAIT_OBJECT_0) {	// Event is singled
		if (!CANCheckEvent(5, 100)) {	// Event is singled
//			ResetEvent(m_hPort5Event);		// Clear event
			ActhWnd = GetActiveWindow();
			MessageBox(ActhWnd, "Port 5 Event!", "Event!", MB_OK | MB_ICONERROR );
		}
	}
}

void Port6EventHandle(void *dummy)
{
	HWND	ActhWnd;

	while (1) {
//		if (WaitForSingleObject (m_hPort6Event, 1000) == WAIT_OBJECT_0) {	// Event is singled
		if (!CANCheckEvent(6, 100)) {	// Event is singled
//			ResetEvent(m_hPort6Event);		// Clear event
			ActhWnd = GetActiveWindow();
			MessageBox(ActhWnd, "Port 6 Event!", "Event!", MB_OK | MB_ICONERROR );
		}
	}
}

void Port7EventHandle(void *dummy)
{
	HWND	ActhWnd;

	while (1) {
//		if (WaitForSingleObject (m_hPort7Event, 1000) == WAIT_OBJECT_0) {	// Event is singled
		if (!CANCheckEvent(7, 100)) {	// Event is singled
//			ResetEvent(m_hPort7Event);		// Clear event
			ActhWnd = GetActiveWindow();
			MessageBox(ActhWnd, "Port 7 Event!", "Event!", MB_OK | MB_ICONERROR );
		}
	}
}

void Port8EventHandle(void *dummy)
{
	HWND	ActhWnd;

	while (1) {
//		if (WaitForSingleObject (m_hPort8Event, 1000) == WAIT_OBJECT_0) {	// Event is singled
		if (!CANCheckEvent(8, 100)) {	// Event is singled
//			ResetEvent(m_hPort8Event);		// Clear event
			ActhWnd = GetActiveWindow();
			MessageBox(ActhWnd, "Port 8 Event!", "Event!", MB_OK | MB_ICONERROR );
		}
	}
}

void Port9EventHandle(void *dummy)
{
	HWND	ActhWnd;

	while (1) {
//		if (WaitForSingleObject (m_hPort9Event, 1000) == WAIT_OBJECT_0) {	// Event is singled
		if (!CANCheckEvent(9, 100)) {	// Event is singled
//			ResetEvent(m_hPort9Event);		// Clear event
			ActhWnd = GetActiveWindow();
			MessageBox(ActhWnd, "Port 9 Event!", "Event!", MB_OK | MB_ICONERROR );
		}
	}
}

void Port10EventHandle(void *dummy)
{
	HWND	ActhWnd;

	while (1) {
//		if (WaitForSingleObject (m_hPort10Event, 1000) == WAIT_OBJECT_0) {	// Event is singled
		if (!CANCheckEvent(10, 100)) {	// Event is singled
//			ResetEvent(m_hPort10Event);		// Clear event
			ActhWnd = GetActiveWindow();
			MessageBox(ActhWnd, "Port 10 Event!", "Event!", MB_OK | MB_ICONERROR );
		}
	}
}

