// 841MView.h : interface of the CP841MView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_841MVIEW_H__B7F684E1_353E_11D1_B30E_00C06C008DD6__INCLUDED_)
#define AFX_841MVIEW_H__B7F684E1_353E_11D1_B30E_00C06C008DD6__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CP841MView : public CFormView
{
protected: // create from serialization only
	CP841MView();
	DECLARE_DYNCREATE(CP841MView)

public:
	//{{AFX_DATA(CP841MView)
	enum { IDD = IDD_PCL841_FUNCTION_FRAME };
	UINT	m_AcpCode;
	UINT	m_AcpMask;
	UINT	m_BTR0;
	UINT	m_BTR1;
	CString	m_EventLog;
	BOOL	m_EnReceiveInt;
	BOOL	m_EnTransmitInt;
	BOOL	m_EnErrorInt;
	BOOL	m_EnOverrunInt;
	UINT	m_IntMask;
	UINT	m_OutCtrlCode;
	UINT	m_Port;
	CString	m_RxBuf;
	UINT	m_RxID;
	UINT	m_TimeOut;
	CString	m_TxBuf;
	UINT	m_TxID;
	BOOL	m_WaitForComplete;
	CString	m_HostID;
	CString	m_DeviceName;
	CString	m_DeviceNum;
	//}}AFX_DATA

// Attributes
public:
	UINT	m_uDevNum;

	CP841MDoc* GetDocument();

	boolean	m_bRepeat;
	boolean	m_bThreadCreated[2];	// Switch for event handling routine continue or stop
	CWinThread*	m_p1Thread;			// Port 1 event thread
	CWinThread*	m_p2Thread;			// Port 2 event thread

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CP841MView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CP841MView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	char cTxBuf[30];
	char cReBuf[30];
	//{{AFX_MSG(CP841MView)
	afx_msg void OnCANClose();
	afx_msg void OnCANEnableMessaging();
	afx_msg void OnCANHwReset();
	afx_msg void OnCANInit();
	afx_msg void OnCANOpen();
	afx_msg void OnCANQueryMsg();
	afx_msg void OnCANReset();
	afx_msg void OnCANSendMsg();
	afx_msg void OnCANSetAcp();
	afx_msg void OnCANSetBaud();
	afx_msg void OnCANSetNormal();
	afx_msg void OnCANSetOutCtrl();
	afx_msg void OnCANWaitForMsg();
	afx_msg void OnRegisterView();
	afx_msg void OnChangePortEdit();
	afx_msg void OnChangeAcpCodeEdit();
	afx_msg void OnChangeAcpMaskEdit();
	afx_msg void OnChangeBTR0Edit();
	afx_msg void OnChangeBTR1Edit();
	afx_msg void OnEnableWaitChk();
	afx_msg void OnIntMaskChk1();
	afx_msg void OnIntMaskChk2();
	afx_msg void OnIntMaskChk3();
	afx_msg void OnIntMaskChk4();
	afx_msg void OnChangeIntMaskEdit();
	afx_msg void OnChangeOutCtrlEdit();
	afx_msg void OnChangeTimeOutEdit();
	afx_msg void OnChangeTransferBufEdit();
	afx_msg void OnChangeTxIDEdit();
	afx_msg void OnHandlingEvent();
	afx_msg LRESULT OnCANTransmitComplete(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnCANMessage(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnCANError(WPARAM wParam, LPARAM lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#ifndef _DEBUG  // debug version in 841MView.cpp
inline CP841MDoc* CP841MView::GetDocument()
   { return (CP841MDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_841MVIEW_H__B7F684E1_353E_11D1_B30E_00C06C008DD6__INCLUDED_)
